<?php

/**
 * The file that defines the merchants attributes
 *
 * A class definition that includes attributes and functions used across the
 * admin area.
 *
 * @link       https://webappick.com/
 * @since      1.0.0
 *
 * @package    Woo_Feed
 * @subpackage Woo_Feed/includes
 * @author     Ohidul Islam <wahid@webappick.com>
 */

class Woo_Feed_Default_Attributes
{

    public $wooAttributes = array();


    public function __construct()
    {

    }

    public function merchants(){
        $merchants=array(
            "--1"               => "Feed Engine",
            "custom"            =>"Custom Feed",
            "---1"              => "",

            "--2"               => "Feed Template",
            "google"            =>"Google Shopping",
            "google_local"      =>"Google Local Product Inventory",
            "adwords"           =>"Google Adwords",
            "facebook"          =>"Facebook",
            "shopping"          =>"eBay (Shopping.com)",
            "adroll"            =>"AdRoll",
            "adform"            =>"AdForm",
            "nextag"            =>"Nextag",
            "pricegrabber"      =>"Price Grabber",
            "polyvore"          =>"Polyvore",
            "pricerunner"       =>"PriceRunner",
            "kelkoo"            =>"Kelkoo",
            "shopzilla"         =>"Shopzilla",
            "shopmania"         =>"Shopmania",
            "shopbot"           =>"Shopbot",
            "bing"              =>"Bing",
            "become"            =>"Become",
            "connexity"         =>"Connexity",

            "pricespy"          =>"PriceSpy",
            "prisjakt"          =>"Prisjakt",
            "twenga"            =>"Twenga",
            "fruugo"            =>"Fruugo",
            "bonanza"           =>"Bonanza",
            "bol"               =>"Bol.com",
            "leguide"           =>"LeGuide",
            "real"              =>"Real",
            "crowdfox"          =>"Crowdfox",
            "jet"               =>"Jet.com",
            "wish"              =>"Wish.com",
            "---2"              =>"",
            "--3"               =>"Amazon Template",
            "amazon_clothing"   =>"Clothing",
            "amazon_clothing"   =>"Luggage & Travel Accessories",
            "amazon_lighting"   =>"Lighting",
            "amazon_wireless"   =>"Cell Phones & Accessories (Wireless)",
            "amazon_autoaccessory"   =>"Automotive & Powersports (Parts & Accessories)",
            "amazon_tiresandwheels"   =>"Automotive & Powersports (Tires & Wheels)",
            "amazon_home"       =>"Home, Home Decor, Kitchen & Garden",
            "amazon_home"       =>"Furniture",
            "amazon_health"     =>"Health",
            "amazon_baby"     =>"Baby",
            "amazon_BookLoader"     =>"Book",
            "amazon_CameraAndPhoto"     =>"Camera And Photo",
            "amazon_foodandbeverages"     =>"Grocery & Gourmet Food",
            "amazon_computers"     =>"Computers",
            "amazon_ConsumerElectronics"     =>"Consumer Electronics",
            "amazon_entertainmentcollectibles"     =>"Entertainment Collectibles",
            "amazon_homeimprovement"     =>"Home Improvement",
            "amazon_office"     =>"Office",
            "amazon_petsupplies"     =>"Pet Supplies",
            "amazon_sportsmemorabilia"     =>"Sports Memorabilia",
            "amazon_shoes"     =>"Shoes",
            "amazon_sports"     =>"Sports",
            "amazon_toys"     =>"Toys",
            "amazon_TradingCards"     =>"Trading Cards",
            "amazon_watches"     =>"Watches",
            "amazon_jewelry"     =>"Jewelry",
            "amazon_jewelry_fr"     =>"Jewelry French",
            "---3"              => "",
        );
        return $merchants;
    }


        /**
         * Dropdown of Attribute List
         *
         * @param string $merchant
         * @param string $selected
         * @return string
         */
    
    public function getAttributeDropDown($merchant,$selected = "")
    {
            $str = "<option></option>";
            $method=$merchant."Attribute";
            foreach ($this->$method() as $key => $value) {
                if (substr($key, 0, 2) == "--") {
                    $str .= "<optgroup label='$value'>";
                } elseif (substr($key, 0, 2) == "---") {
                    $str .= "</optgroup>";
                } else {
                    $sltd = "";
                    if ($selected == $key)
                        $sltd = 'selected="selected"';
                    $str .= "<option $sltd value='$key'>" . $value . "</option>";
                }

            }
            return $str;
    }


    public function amazon_foodandbeverages_first_row(){
        $row=array("TemplateType=foodandbeverages","Version=2016.1108","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_health_first_row(){
        $row=array("TemplateType=health","Version=2016.0825","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_home_first_row(){
        $row=array("TemplateType=home","Version=2016.0909","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_clothing_first_row(){
        $row=array("TemplateType=clothing","Version=2016.0721","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }

    public function amazon_jewelry_first_row(){
        $row=array("TemplateType=jewelry","Version=2016.1122","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }

   

    public function amazon_lighting_first_row(){
        $row=array("TemplateType=lighting","Version=2016.1123","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }

    public function amazon_baby_first_row (){
        $row=array("TemplateType=Baby","Version=2015.1207","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","","Offer - These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","","","Dimensions - These attributes specify the size and weight of a product","","","","","","","","","","","","","","Discovery - These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","Images - These attributes provide links to images for a product","","","","","Fulfillment - Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation - Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance - Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_wireless_first_row (){
        $row=array("TemplateType=wireless","Version=2016.0822","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","",);
        return $row;
    }

    public function amazon_autoaccessory_first_row (){
        $row=array("TemplateType=autoaccessory","Version=2016.0909","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_tiresandwheels_first_row (){
        $row=array("TemplateType=tiresandwheels","Version=2016.1121","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","Images-These attributes provide links to images for a product","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_BookLoader_first_row (){
        $row=array("TemplateType=BookLoader","Version=2016.0114","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","Offer - These attributes are required to make your item buyable for customers on the site","","","","","","","","","","Discovery - These attributes have an effect on how customers can find your product on the site using browse or search","","","","","Images - These attributes provide links to images for a product","","","","","","","Fulfillment - Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }

    public function amazon_CameraAndPhoto_first_row (){
        $row=array("TemplateType=CameraAndPhoto","Version=2015.1203","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","","Offer - These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","Dimensions - These attributes specify the size and weight of a product","","","","","","","","Discovery - These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","Images - These attributes provide links to images for a product","","","","Fulfillment - Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Compliance - Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_computers_first_row (){
        $row=array("TemplateType=computers","Version=2016.0719","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_ConsumerElectronics_first_row (){
        $row=array("TemplateType=ConsumerElectronics","Version=2015.1224","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","","Offer - These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","Dimensions - These attributes specify the size and weight of a product","","","","","","","","Discovery - These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","Images - These attributes provide links to images for a product","","","","Fulfillment - Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Compliance - Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_entertainmentcollectibles_first_row (){
        $row=array("TemplateType=entertainmentcollectibles","Version=2016.0719","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","Images-These attributes provide links to images for a product","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_homeimprovement_first_row (){
        $row=array("TemplateType=homeimprovement","Version=2016.0909","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_musicalinstruments_first_row (){
        $row=array("TemplateType=musicalinstruments","Version=2016.0822","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","Images-These attributes provide links to images for a product","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_office_first_row (){
        $row=array("TemplateType=office","Version=2016.0822","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","Images-These attributes provide links to images for a product","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_outdoors_first_row (){
        $row=array("TemplateType=outdoors","Version=2016.0721","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","","","","","","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_petsupplies_first_row (){
        $row=array("TemplateType=petsupplies","Version=2016.0617","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_shoes_first_row (){
        $row=array("TemplateType=shoes","Version=2016.0721","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_sports_first_row (){
        $row=array("TemplateType=sports","Version=2016.0923","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","","","","","","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Variation-Populate these attributes if your product is available in different variations (for example color or wattage)","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_sportsmemorabilia_first_row (){
        $row=array("TemplateType=sportsmemorabilia","Version=2015.1203","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","Images-These attributes provide links to images for a product","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","",);
        return $row;
    }
    public function amazon_toys_first_row (){
        $row=array("TemplateType=toys","Version=2016.1109","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","","","","","","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_TradingCards_first_row (){
        $row=array("TemplateType=TradingCards","Version=2016.0213","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","Offer - These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","Dimensions - These attributes specify the size and weight of a product","","","","","","","","","Discovery - These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","","","","","Images - These attributes provide links to images for a product","","","","","","","Fulfillment - Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_watches_first_row (){
        $row=array("TemplateType=watches","Version=2016.0719","The top 3 rows are for Amazon.com use only. Do not modify or delete the top 3 rows.","","","","","","","","Offer-These attributes are required to make your item buyable for customers on the site","","","","","","","","","","","","","","","","","","","","","","","Dimensions-These attributes specify the size and weight of a product","","Discovery-These attributes have an effect on how customers can find your product on the site using browse or search","","","","","","","","","","","","","","Images-These attributes provide links to images for a product","","","","Fulfillment-Use these columns to provide fulfillment-related information for either Amazon-fulfilled (FBA) or seller-fulfilled orders.","","","","","","","Compliance-Attributes used to comply with consumer laws in the country or region where the item is sold","","","Ungrouped - These attributes create rich product listings for your buyers.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }

    public function amazon_watchesAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "brand_name" => "Brand",
            "item_type" => "Item Type Keyword",
            "product_description" => "Product Description",
            "update_delete" => "Update Delete",
            "standard_price" => "Standard Price",
            "condition_type" => "Item Condition",
            "condition_note" => "Condition Note",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "product_tax_code" => "Product Tax Code",
            "item_package_quantity" => "Item Package Quantity",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "quantity" => "Quantity",
            "restock_date" => "Restock Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued By Manufacturer",
            "missing_keyset_reason" => "Registered Parameter",
            "make_an_offer_eligibility" => "Make an Offer Eligible",
            "minimum_accept_percentage" => "Make an Offer Auto-Accept Threshold",
            "maximum_reject_percentage" => "Make an Offer Auto-Reject Threshold",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "target_audience_keywords" => "Target Audience",
            "catalog_number" => "Merchant Catalog Number",
            "specific_uses_keywords1" => "Intended Use1",
            "specific_uses_keywords2" => "Intended Use2",
            "specific_uses_keywords3" => "Intended Use3",
            "specific_uses_keywords4" => "Intended Use4",
            "specific_uses_keywords5" => "Intended Use5",
            "thesaurus_subject_keywords" => "Subject Matter",
            "generic_keywords" => "Search Terms",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_length" => "Package Length",
            "package_weight" => "Package Weight",
            "package_height" => "Package Height",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "package_width" => "Package Width",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "prop_65" => "Prop 65",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "department_name" => "Gender",
            "thesaurus_attribute_keywords1" => "Other Attributes1",
            "thesaurus_attribute_keywords2" => "Other Attributes2",
            "thesaurus_attribute_keywords3" => "Other Attributes3",
            "thesaurus_attribute_keywords4" => "Other Attributes4",
            "thesaurus_attribute_keywords5" => "Other Attributes5",
            "band_material_type" => "Band Material Type",
            "band_size" => "Band Size",
            "band_width" => "Band Width",
            "band_width_unit_of_measure" => "Band Width Unit Of Measure",
            "band_color" => "Band Color",
            "clasp_type" => "Clasp Type",
            "case_material_type" => "Case Material Type",
            "case_thickness" => "Case Size Thickness",
            "case_diameter" => "Case Diameter",
            "case_diameter_unit_of_measure" => "Case Diameter Unit Of Measure",
            "metal_stamp" => "Metal Stamp",
            "dial_color" => "Dial Color",
            "bezel_material_type" => "Bezel Material Type",
            "bezel_function" => "Bezel Function",
            "dial_window_material_type" => "Crystal",
            "display_type" => "Display",
            "item_shape" => "Shape",
            "watch_movement_type" => "Watch Movement Type",
            "calendar_type" => "Calendar Type",
            "water_resistance_depth" => "Water Resistance Depth",
            "water_resistance_depth_unit_of_measure" => "Water Resistance Depth Unit Of Measure",
            "warranty_type" => "Warranty Type",
            "special_features" => "Additional Features",
            "subject_character" => "Character",
            "grade_rating" => "Grade Rating",
            "authenticated_by" => "Authenticated By",
            "model_year" => "Model Year",
        );
        return $attributes;
    }
    public function amazon_TradingCardsAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "update_delete" => "Update Delete",
            "external_product_id_type" => "Product ID Type",
            "external_product_id" => "Product ID",
            "item_type" => "Item Type",
            "manufacturer" => "Manufacturer",
            "brand_name" => "Brand Name",
            "item_name" => "Product Name",
            "product_description" => "Product Description",
            "feed_product_type" => "Product Type",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "quantity" => "Quantity",
            "standard_price" => "Standard Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "item_package_quantity" => "Shipping Quantity",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "fulfillment_latency" => "Fulfillment Latency",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "condition_note" => "Condition Note",
            "restock_date" => "Restock Date",
            "minimum_accept_percentage" => "Auto-accept threshold %",
            "merchant_shipping_group_name" => "Shipping-Template",
            "maximum_reject_percentage" => "Auto-reject threshold %",
            "make_an_offer_eligibility" => "Make an Offer eligible",
            "item_display_width" => "Item Width",
            "item_display_height" => "Item Height",
            "item_display_length" => "Item Length",
            "display_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "item_display_weight" => "Item Weight",
            "item_display_weight_unit_of_measure" => "Item Display Weight Unit Of Measure",
            "item_display_diameter" => "Item Diameter",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "website_shipping_weight" => "Total Shipping Weight",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "generic_keywords1" => "Search Terms1",
            "generic_keywords2" => "Search Terms2",
            "generic_keywords3" => "Search Terms3",
            "generic_keywords4" => "Search Terms4",
            "generic_keywords5" => "Search Terms5",
            "platinum_keywords1" => "Platinum Keywords1",
            "platinum_keywords2" => "Platinum Keywords2",
            "platinum_keywords3" => "Platinum Keywords3",
            "platinum_keywords4" => "Platinum Keywords4",
            "platinum_keywords5" => "Platinum Keywords5",
            "main_image_url" => "Main Image URL",
            "offer_image1" => "Offer Image1",
            "offer_image2" => "Offer Image2",
            "offer_image3" => "Offer Image3",
            "offer_image4" => "Offer Image4",
            "offer_image5" => "Offer Image5",
            "main_offer_image" => "Main Offer Image",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "sport_type" => "Sport Type",
            "model_year_range" => "Year Range",
            "model_year" => "Year",
            "certificate_number" => "Authentication Number",
            "grade_rating" => "Grade Rating",
            "graded_by" => "Grading Provided By",
            "is_autographed" => "Is Autographed",
            "signed_by" => "Signed By",
            "unit_count_type" => "Lot Type",
            "unit_count" => "Lot Count",
            "league_name" => "League Name",
            "team_name1" => "Team Name1",
            "team_name2" => "Team Name2",
            "team_name3" => "Team Name3",
            "team_name4" => "Team Name4",
            "event_name" => "Event Name",
            "seasons" => "Season",
            "parallel_type" => "Type of Parallel Card",
            "insert_type" => "Insert Set Name",
            "card_number" => "Card Number",
            "special_features" => "Special Feature",
        );
        return $attributes;
    }
    public function amazon_toysAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_type" => "Item Type Keyword",
            "item_name" => "Product Name",
            "brand_name" => "Brand Name",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "product_description" => "Product Description",
            "edition" => "Edition",
            "update_delete" => "Update Delete",
            "related_product_id_type" => "Related Product Identifier Type",
            "related_product_id" => "Related Product Identifier",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "offering_end_date" => "Stop Selling Date",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "map_price" => "Minimum Advertised Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "standard_price" => "Standard Price",
            "quantity" => "Quantity",
            "merchant_release_date" => "Release Date",
            "fulfillment_latency" => "Production Time",
            "restock_date" => "Restock Date",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "item_package_quantity" => "Package Quantity",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "missing_keyset_reason" => "Registered Parameter",
            "merchant_shipping_group_name" => "Shipping-Template",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_height" => "Item Height",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords1" => "Target Audience1",
            "target_audience_keywords2" => "Target Audience2",
            "target_audience_keywords3" => "Target Audience3",
            "thesaurus_subject_keywords" => "Subject Matter",
            "generic_keywords" => "Search Terms",
            "catalog_number" => "Catalog Number",
            "style_keywords" => "Style-specific Terms",
            "swatch_image_url" => "Swatch Image URL",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_length" => "Package Length",
            "package_width" => "Package Width",
            "package_height" => "Package Height",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "safety_warning" => "Safety Warning",
            "country_of_origin" => "Country of Publication",
            "mfg_minimum" => "Minimum Manufacturer Age Recommended",
            "mfg_minimum_unit_of_measure" => "Minimum Manufacturer Age Recommended Unit Of Measure",
            "mfg_maximum" => "Maximum Manufacturer Age Recommended",
            "mfg_maximum_unit_of_measure" => "Maximum Manufacturer Age Recommended Unit Of Measure",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "theme" => "Theme",
            "subject_character" => "Character",
            "educational_objective" => "Educational Objective",
            "size_name" => "Size",
            "size_map" => "Size Map",
            "scale_name" => "Scale",
            "collection_name" => "Collection Name",
            "initial_print_run_rarity" => "rarity",
            "specific_uses_for_product" => "Specific Uses For Product",
            "genre" => "Genre",
            "material_type" => "Material Type",
            "assembly_time" => "Assembly Time",
            "assembly_time_unit_of_measure" => "Assembly Time Unit Of Measure",
            "warranty_description" => "Manufacturer Warranty Description",
            "number_of_pieces" => "Number of Pieces",
            "number_of_players" => "Number of Players",
            "maximum_weight_recommendation" => "Weight Supported",
            "maximum_weight_recommendation_unit_of_measure" => "Maximum Weight Recommendation Unit Of Measure",
            "color_name" => "Colour",
            "color_map" => "Colour Map",
        );
        return $attributes;
    }
    public function amazon_sportsmemorabiliaAttributes (){
        $attributes = array(
            "update_delete" => "Update Delete",
            "item_sku" => "Seller SKU",
            "external_product_id_type" => "Product ID Type",
            "external_product_id" => "Product ID",
            "item_type" => "Category (item-type)",
            "manufacturer" => "Manufacturer",
            "brand_name" => "Brand Name",
            "item_name" => "Product Name",
            "product_description" => "Product Description",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "quantity" => "Quantity",
            "standard_price" => "Standard Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "make_an_offer_minimum_percentage" => "Make an Offer Eligible?",
            "item_package_quantity" => "Shipping Quantity",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "fulfillment_latency" => "Fulfillment Latency",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "condition_note" => "Condition Note",
            "restock_date" => "Restock Date",
            "minimum_accept_percentage" => "Auto-accept threshold %",
            "merchant_shipping_group_name" => "Shipping-Template",
            "maximum_reject_percentage" => "Auto-reject threshold %",
            "make_an_offer_eligibility" => "Make an Offer eligible",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "website_shipping_weight" => "Total Shipping Weight",
            "bullet_point1" => "Key Product Features",
            "bullet_point2" => "Key Product Features",
            "bullet_point3" => "Key Product Features",
            "bullet_point4" => "Key Product Features",
            "bullet_point5" => "Key Product Features",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL",
            "other_image_url2" => "Other Image URL",
            "other_image_url3" => "Other Image URL",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "sport_type" => "Sport Type",
            "model_year" => "Year",
            "athlete" => "Player Name",
            "authenticated_by" => "Authentication Provided By",
            "is_autographed" => "Is Autographed",
            "special_features" => "Game Used",
            "unit_count_type" => "Lot Type",
            "league_name" => "League Name",
            "team_name" => "Team Name",
            "seasons" => "Season",
            "style_name" => "Jersey Type",
        );
        return $attributes;
    }
    public function amazon_sportsAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "product_description" => "Product Description",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "feed_product_type" => "Product Type",
            "brand_name" => "Brand Name",
            "item_type" => "Item Type Keyword",
            "update_delete" => "Update Delete",
            "standard_price" => "Standard Price",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "quantity" => "Quantity",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "product_tax_code" => "Product Tax Code",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "item_package_quantity" => "Package Quantity",
            "number_of_items" => "Number of Items",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "map_price" => "Minimum Advertised Price",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_display_width" => "Width",
            "item_display_width_unit_of_measure" => "Item Display Width Unit Of Measure",
            "item_display_length" => "Item Display Length",
            "item_display_length_unit_of_measure" => "Item Display Length Unit Of Measure",
            "item_display_weight" => "Item Display Weight",
            "item_display_weight_unit_of_measure" => "Item Display Weight Unit Of Measure",
            "item_volume" => "Volume",
            "item_volume_unit_of_measure" => "Item Volume Unit Of Measure",
            "item_display_height" => "Display Height",
            "item_display_height_unit_of_measure" => "Item Display Height Unit Of Measure",
            "item_height" => "Item Height",
            "item_height_unit_of_measure" => "Item Height Unit Of Measure",
            "item_length" => "Item Length",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "item_width" => "Item Width",
            "item_width_unit_of_measure" => "Item Width Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords1" => "Target Audience1",
            "target_audience_keywords2" => "Target Audience2",
            "target_audience_keywords3" => "Target Audience3",
            "thesaurus_subject_keywords" => "Subject Matter",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "swatch_image_url" => "Swatch Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "country_of_origin" => "Country of Publication",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "fabric_type" => "Fabric Type",
            "import_designation" => "Import Designation",
            "legal_compliance_certification_metadata" => "Please provide the Executive Number (EO) required for sale into California.",
            "legal_compliance_certification_expiration_date" => "Please provide the expiration date of the EO Number.",
            "mfg_warranty_description_type" => "Mfg Warranty Type (i.e. Parts, Labor)",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "closure_type" => "Closure Type",
            "pattern_name" => "Design",
            "country_as_labeled" => "Country as Labeled",
            "fur_description" => "Fur Description",
            "material_type" => "Material Type",
            "seasons" => "Seasons",
            "size_map" => "Size Map",
            "size_name" => "Size",
            "skill_level" => "Skill Level",
            "sport_type" => "Sport Type",
            "floor_length" => "Floor Length",
            "floor_length_unit_of_measure" => "Floor Length Unit Of Measure",
            "floor_width" => "Floor Width",
            "floor_width_unit_of_measure" => "Floor Width Unit Of Measure",
            "watch_movement_type" => "Watch Movement Type",
            "construction_type" => "Construction Type",
            "floor_area" => "Floor Area",
            "floor_area_unit_of_measure" => "Floor Area Unit Of Measure",
            "bottom_style" => "Bottom Style",
            "department_name" => "Department",
            "leg_style" => "Leg Style",
            "neck_style" => "Neck Style",
            "pattern_type" => "Pattern Style",
            "pocket_description" => "Pocket Description",
            "shoe_width" => "Shoe Width",
            "sleeve_type" => "Sleeve Type",
            "sleeve_length" => "Sleeve Length",
            "sleeve_length_unit_of_measure" => "Sleeve Length Unit Of Measure",
            "rise_style" => "Sock Height",
            "strap_type" => "Strap Type",
            "support_type" => "Support Type",
            "theme" => "Theme",
            "top_style" => "Top Style",
            "ultraviolet_light_protection" => "UV Protection",
            "waist_size" => "Waist Size",
            "waist_size_unit_of_measure" => "Waist Size Unit Of Measure",
            "wheel_type" => "Wheel Type",
            "golf_club_flex" => "Flex",
            "golf_club_loft" => "Loft",
            "grip_size" => "Grip Size",
            "grip_type" => "Grip Type",
            "grip_material_type" => "Grip Material Type",
            "rim_size" => "Rim Size",
            "rim_size_unit_of_measure" => "Rim Size Unit Of Measure",
            "crank_length" => "Crank Length",
            "crank_length_unit_of_measure" => "Crank Length Unit Of Measure",
            "frame_type" => "Frame Type",
            "top_tube_length" => "Top Tube Length",
            "top_tube_length_unit_of_measure" => "Top Tube Length Unit Of Measure",
            "wheel_size" => "Wheel Size",
            "wheel_size_unit_of_measure" => "Wheel Size Unit Of Measure",
            "bike_type" => "Bike Type",
            "inseam_length" => "Inseam Length",
            "brake_style" => "Brake Style",
            "suspension_type" => "Suspension Type",
            "frame_material_type" => "Frame Material Type",
            "line_weight" => "Line Weight",
            "tension_level" => "Tension Supported",
            "fishing_line_type" => "Fishing Line Type",
            "number_of_speeds" => "Number Of Speeds",
            "handle_material" => "Handle Material",
            "display_type" => "Display",
            "water_resistance_depth" => "Water Resistance Depth",
            "water_resistance_depth_unit_of_measure" => "Water Resistance Depth Unit Of Measure",
            "model_name" => "Model Name",
            "number_of_power_levels" => "Number Of Power Levels",
            "capacity" => "Capacity",
            "capacity_unit_of_measure" => "Capacity Unit Of Measure",
            "lens_color" => "Lens Color",
            "fitting_type" => "Fitting Type",
            "number_of_pockets" => "Number Of Pockets",
            "number_of_doors" => "Number Of Doors",
            "number_of_gear_loops" => "Number Of Gear Loops",
            "effective_edge_length" => "Effective Edge Length",
            "effective_edge_length_unit_of_measure" => "Effective Edge Length Unit Of Measure",
            "fill_material_type" => "Fill Material Type",
            "mounting_type" => "Mounting Type",
            "temperature_rating_degrees" => "Temperature Rating",
            "temperature_rating_degrees_unit_of_measure" => "Temperature Rating Degrees Unit Of Measure",
            "blade_length" => "Blade Length",
            "blade_length_unit_of_measure" => "Blade Length Unit Of Measure",
            "lens_material_type" => "Lens Material",
            "lens_type" => "Lens Type",
            "maximum_height_recommendation" => "Maximum Height Recommendation",
            "maximum_height_recommendation_unit_of_measure" => "Maximum Height Recommendation Unit Of Measure",
            "fuel_type" => "Fuel Type",
            "insulation_material_type" => "Insulation Material Type",
            "pad_type" => "Pad Type",
            "outer_material_type" => "ShellMaterial",
            "minimum_torso_measurement" => "Minimum Torso Measurement",
            "occupancy" => "Occupancy",
            "number_of_poles" => "Number Of Poles",
            "light_source_type" => "Light Source Type",
            "objective_lens_diameter" => "Objective Lens Diameter",
            "objective_lens_diameter_unit_of_measure" => "Objective Lens Diameter Unit Of Measure",
            "magnification_maximum" => "Magnification Maximum",
            "league_name" => "League Name",
            "hand_orientation" => "Hand Orientation",
            "shaft_length" => "Shaft Length",
            "shaft_length_unit_of_measure" => "Shaft Length Unit Of Measure",
            "shaft_material" => "Shaft Material",
            "item_shape" => "Shape",
            "display_maximum_weight_recommendation" => "Display Maximum Weight Recommendation",
            "display_maximum_weight_recommendation_unit_of_measure" => "Display Maximum Weight Recommendation Unit Of Measure",
            "seating_capacity" => "Seating Capacity",
            "fit_type" => "Fit Type",
            "athlete" => "Athlete",
            "style_name" => "Style Name",
            "team_name" => "Team Name",
            "power_source_type" => "Power Source",
            "special_features" => "Additional Features",
            "capacity_name_unit_of_measure" => "Usage Capacity Unit Of Measure",
            "load_capacity" => "Load Capacity",
            "load_capacity_unit_of_measure" => "Load Capacity Unit Of Measure",
            "capacity_name" => "Number of Horses",
            "specific_uses_for_product" => "Specific Uses For Product",
            "compatible_devices" => "Compatible Devices",
            "maximum_weight_recommendation" => "Weight Supported",
            "maximum_weight_recommendation_unit_of_measure" => "Maximum Weight Recommendation Unit Of Measure",
            "maximum_weight_capacity" => "Maximum Weight",
            "maximum_weight_capacity_unit_of_measure" => "Maximum Weight Capacity Unit Of Measure",
            "unit_count_type" => "Unit Count Type",
            "batteries_required" => "Are Batteries Required",
            "battery_type" => "Battery Type",
            "number_of_batteries" => "Number of Batteries Required",
            "battery_average_life" => "Battery Average Life",
            "lithium_battery_packaging" => "Lithium Battery Packaging",
            "lithium_battery_weight" => "Lithium Battery Weight",
            "unit_count" => "Unit Count",
            "inseam_length_unit_of_measure" => "Inseam Length Unit Of Measure",
            "lithium_battery_weight_unit_of_measure" => "Unit of measure of lithium battery weight",
        );
        return $attributes;
    }
    public function amazon_shoesAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "item_name" => "Product Name",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "brand_name" => "Brand",
            "product_description" => "Product Description",
            "item_type" => "Item Type",
            "model" => "Style Number",
            "update_delete" => "Update Delete",
            "standard_price" => "Standard Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "product_tax_code" => "Product Tax Code",
            "fulfillment_latency" => "Fulfillment Latency",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "quantity" => "Quantity",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "item_package_quantity" => "Item Package Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer?",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_height" => "Item Height",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "bullet_point1" => "Bullet Point1",
            "bullet_point2" => "Bullet Point2",
            "bullet_point3" => "Bullet Point3",
            "bullet_point4" => "Bullet Point4",
            "bullet_point5" => "Bullet Point5",
            "generic_keywords" => "Search Terms",
            "style_keywords1" => "Style Keyword1",
            "style_keywords2" => "Style Keyword2",
            "style_keywords3" => "Style Keyword3",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "swatch_image_url" => "Swatch Image URL",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "import_designation" => "Import Designation",
            "style_name" => "Style Name",
            "subject_character" => "character",
            "model_year" => "Model Year",
            "closure_type" => "Closure Type",
            "department_name" => "Department",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "size_name" => "Size",
            "material_type1" => "Material Fabric1",
            "material_type2" => "Material Fabric2",
            "country_as_labeled" => "Country as Labeled",
            "fur_description" => "Fur Description",
            "pattern_type" => "Pattern Style",
            "lifestyle" => "Occasion Lifestyle",
            "special_features" => "Special Features",
            "size_map" => "Size Map",
            "lens_color" => "Lens Color",
            "lens_color_map" => "Lens Color Map",
            "magnification_strength" => "Magnification Strength",
            "frame_material_type" => "Frame Material Type",
            "lens_material_type" => "Lens Material Type",
            "item_shape" => "Item Shape",
            "polarization_type" => "Polarization Type",
            "eyewear_unit_of_measure" => "Eyewear Unit Of Measure",
            "lens_width" => "Lens Width",
            "bridge_width" => "Bridge Width",
            "arm_length" => "Arm Length",
            "lens_height" => "Lens Height",
            "arm_length_unit_of_measure" => "Arm Length Unit of Measure",
            "lens_height_unit_of_measure" => "Lens Height Unit of Measure",
            "lens_width_unit_of_measure" => "Lens Width Unit of Measure",
            "bridge_width_unit_of_measure" => "Unit of Measure for Width of the Bridge",
            "strap_type" => "Strap Type",
            "lining_description" => "Lining Description",
            "shoulder_strap_drop" => "Shoulder Strap Drop",
            "shoulder_strap_drop_unit_of_measure" => "Shoulder Strap Drop Unit Of Measure",
            "sole_material" => "Sole Material",
            "heel_type" => "Heel Type",
            "height_map" => "Shoe Height Map",
            "toe_style" => "Toe Style",
            "arch_type" => "Arch Type",
            "cleat_description" => "Cleat Description",
            "cleat_material_type" => "Cleat Material Type",
            "team_name" => "Team Name",
            "shaft_height" => "Shaft Height",
            "platform_height" => "Platform Height",
            "water_resistance_level" => "Water Resistance Level",
            "special_size_type1" => "Special Size Type1",
            "special_size_type2" => "Special Size Type2",
            "special_size_type3" => "Special Size Type3",
            "special_size_type4" => "Special Size Type4",
            "special_size_type5" => "Special Size Type5",
            "special_size_type6" => "Special Size Type6",
            "special_size_type7" => "Special Size Type7",
            "special_size_type8" => "Special Size Type8",
            "special_size_type9" => "Special Size Type9",
            "special_size_type10" => "Special Size Type10",
            "shaft_height_unit_of_measure" => "Shaft Height Unit Of Measure",
        );
        return $attributes;
    }
    public function amazon_petsuppliesAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "brand_name" => "Brand Name",
            "manufacturer" => "Manufacturer",
            "product_description" => "Product Description",
            "feed_product_type" => "Product Type",
            "item_type" => "Item Type Keyword",
            "part_number" => "Manufacturer Part Number",
            "update_delete" => "Update Delete",
            "model" => "model",
            "item_package_quantity" => "Package Quantity",
            "standard_price" => "Standard Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "quantity" => "Quantity",
            "map_price" => "Minimum Advertised Price",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "restock_date" => "Restock Date",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "max_order_quantity" => "Max Order Quantity",
            "number_of_items" => "Number of Items",
            "offering_start_date" => "Offering Release Date",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_display_weight" => "Item Display Weight",
            "item_display_weight_unit_of_measure" => "Item Display Weight Unit Of Measure",
            "item_display_length" => "Item Display Length",
            "item_display_width" => "DisplayWidth",
            "item_display_height" => "DisplayHeight",
            "display_dimensions_unit_of_measure" => "DisplayDimensionUnitOfMeasure",
            "item_height" => "item-height",
            "item_length" => "item-length",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "item_weight" => "item-weight",
            "item_weight_unit_of_measure" => "item-weight-unit-of-measure",
            "item_width" => "item-width",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "target_audience_base" => "Target Audience",
            "catalog_number" => "MerchantCatalogNumber",
            "generic_keywords" => "Search Terms",
            "thesaurus_subject_keywords" => "Subject Matter",
            "target_audience_keywords1" => "Target Audience1",
            "target_audience_keywords2" => "Target Audience2",
            "specific_uses_keywords1" => "Used For1 - Used For31",
            "specific_uses_keywords2" => "Used For1 - Used For32",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "swatch_image_url" => "Swatch Image URL",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "package_dimensions_unit_of_measure" => "PackageDimensionUnitOfMeasure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "prop_65" => "Prop65",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "safety_warning" => "Safety Warning",
            "country_string" => "CountryAsLabeled",
            "country_of_origin" => "country-of-origin",
            "legal_disclaimer_description" => "legal-disclaimer-description",
            "lighting_facts_image_url" => "Lighting Facts Label",
            "energy_efficiency_image_url" => "Energy Guide Label",
            "breed_recommendation" => "Breed Recommendation",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "special_features" => "Additional Features",
            "directions" => "Directions",
            "ingredients" => "Ingredients",
            "material_type" => "Material Type",
            "closure_type" => "Closure Type",
            "compatible_devices" => "Compatible Devices",
            "age_range_description" => "Age Range Description",
            "included_features" => "Included Features",
            "specific_uses_for_product" => "Specific Uses For Product",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "size_name" => "Size",
            "size_map" => "Size Map",
            "flavor_name" => "Flavor",
            "maximum_weight_recommendation" => "Weight Supported",
            "weight_recommendation_unit_of_measure" => "Weight Recommendation Unit Of Measure",
            "external_testing_certification" => "External Testing Certification",
            "battery_type" => "Battery Type",
            "number_of_batteries" => "Number of Batteries Required",
            "lithium_battery_weight" => "Lithium Battery Weight",
            "wattage" => "Wattage",
            "pattern_name" => "Design",
            "minimum_weight_recommendation" => "Minimum Weight Recommendation",
            "lithium_battery_weight_unit_of_measure" => "lithium_battery_weight_unit_of_measure",
            "wattage_unit_of_measure" => "Wattage Unit of Measure",
        );
        return $attributes;
    }
    public function amazon_outdoorsAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "product_description" => "Product Description",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "feed_product_type" => "Product Type",
            "brand_name" => "Brand Name",
            "item_type" => "Item Type Keyword",
            "update_delete" => "Update Delete",
            "standard_price" => "Standard Price",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "quantity" => "Quantity",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "product_tax_code" => "Product Tax Code",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "item_package_quantity" => "Package Quantity",
            "number_of_items" => "Number of Items",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "map_price" => "Minimum Advertised Price",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_display_width" => "Width",
            "item_display_width_unit_of_measure" => "Item Display Width Unit Of Measure",
            "item_display_length" => "Item Display Length",
            "item_display_length_unit_of_measure" => "Item Display Length Unit Of Measure",
            "item_display_weight" => "Item Display Weight",
            "item_display_weight_unit_of_measure" => "Item Display Weight Unit Of Measure",
            "item_volume" => "Volume",
            "item_volume_unit_of_measure" => "Item Volume Unit Of Measure",
            "item_display_height" => "Display Height",
            "item_display_height_unit_of_measure" => "Item Display Height Unit Of Measure",
            "item_height" => "Item Height",
            "item_height_unit_of_measure" => "Item Height Unit Of Measure",
            "item_length" => "Item Length",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "item_width" => "Item Width",
            "item_width_unit_of_measure" => "Item Width Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords" => "Target Audience",
            "thesaurus_subject_keywords" => "Subject Matter",
            "generic_keywords" => "Search Terms",
            "style_keywords" => "Style Keyword",
            "main_image_url" => "Main Image URL",
            "swatch_image_url" => "Swatch Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "country_of_origin" => "Country of Publication",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "fabric_type" => "Fabric Type",
            "import_designation" => "Import Designation",
            "mfg_warranty_description_type" => "Mfg Warranty Type",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "closure_type" => "Closure Type",
            "pattern_name" => "Design",
            "country_as_labeled" => "Country as Labeled",
            "fur_description" => "Fur Description",
            "material_type" => "Material Type",
            "seasons" => "Seasons",
            "size_map" => "Size Map",
            "size_name" => "Size",
            "skill_level" => "Skill Level",
            "sport_type" => "Sport Type",
            "floor_length" => "Floor Length",
            "floor_length_unit_of_measure" => "Floor Length Unit Of Measure",
            "floor_width" => "Floor Width",
            "floor_width_unit_of_measure" => "Floor Width Unit Of Measure",
            "construction_type" => "Construction Type",
            "floor_area" => "Floor Area",
            "floor_area_unit_of_measure" => "Floor Area Unit Of Measure",
            "bottom_style" => "Bottom Style",
            "department_name" => "Department",
            "leg_style" => "Leg Style",
            "neck_style" => "Neck Style",
            "pattern_type" => "Pattern Style",
            "pocket_description" => "Pocket Description",
            "shoe_width" => "Shoe Width",
            "sleeve_type" => "Sleeve Type",
            "sleeve_length" => "Sleeve Length",
            "sleeve_length_unit_of_measure" => "Sleeve Length Unit Of Measure",
            "rise_style" => "Sock Height",
            "strap_type" => "Strap Type",
            "support_type" => "Support Type",
            "theme" => "Theme",
            "top_style" => "Top Style",
            "ultraviolet_light_protection" => "UV Protection",
            "waist_size" => "Waist Size",
            "waist_size_unit_of_measure" => "Waist Size Unit Of Measure",
            "rim_size" => "Rim Size",
            "rim_size_unit_of_measure" => "Rim Size Unit Of Measure",
            "crank_length" => "Crank Length",
            "crank_length_unit_of_measure" => "Crank Length Unit Of Measure",
            "frame_type" => "Frame Type",
            "top_tube_length" => "Top Tube Length",
            "top_tube_length_unit_of_measure" => "Top Tube Length Unit Of Measure",
            "wheel_size" => "Wheel Size",
            "wheel_size_unit_of_measure" => "Wheel Size Unit Of Measure",
            "bike_type" => "Bike Type",
            "inseam_length" => "Inseam Length",
            "inseam_length_unit_of_measure" => "Inseam Length Unit Of Measure",
            "brake_style" => "Brake Style",
            "suspension_type" => "Suspension Type",
            "frame_material_type" => "Frame Material Type",
            "tension_level" => "Tension Supported",
            "number_of_speeds" => "Number Of Speeds",
            "number_of_power_levels" => "Number Of Power Levels",
            "capacity" => "Capacity",
            "capacity_unit_of_measure" => "Capacity Unit Of Measure",
            "lens_color" => "Lens Color",
            "fitting_type" => "Fitting Type",
            "number_of_pockets" => "Number Of Pockets",
            "number_of_doors" => "Number Of Doors",
            "number_of_gear_loops" => "Number Of Gear Loops",
            "effective_edge_length" => "Effective Edge Length",
            "effective_edge_length_unit_of_measure" => "Effective Edge Length Unit Of Measure",
            "fill_material_type" => "Fill Material Type",
            "mounting_type" => "Mounting Type",
            "temperature_rating_degrees" => "Temperature Rating",
            "temperature_rating_degrees_unit_of_measure" => "Temperature Rating Degrees Unit Of Measure",
            "blade_length" => "Blade Length",
            "blade_length_unit_of_measure" => "Blade Length Unit Of Measure",
            "lens_material_type" => "Lens Material",
            "lens_type" => "Lens Type",
            "maximum_height_recommendation" => "Maximum Height Recommendation",
            "maximum_height_recommendation_unit_of_measure" => "Maximum Height Recommendation Unit Of Measure",
            "fuel_type" => "Fuel Type",
            "insulation_material_type" => "Insulation Material Type",
            "pad_type" => "Pad Type",
            "outer_material_type" => "ShellMaterial",
            "minimum_torso_measurement" => "Minimum Torso Measurement",
            "occupancy" => "Occupancy",
            "number_of_poles" => "Number Of Poles",
            "light_source_type" => "Light Source Type",
            "objective_lens_diameter" => "Objective Lens Diameter",
            "objective_lens_diameter_unit_of_measure" => "Objective Lens Diameter Unit Of Measure",
            "magnification_maximum" => "Magnification Maximum",
            "item_shape" => "Shape",
            "seating_capacity" => "Seating Capacity",
            "fit_type" => "Fit Type",
            "power_source_type" => "Power Source",
            "special_features" => "Additional Features",
            "capacity_name_unit_of_measure" => "Usage Capacity Unit Of Measure",
            "load_capacity" => "Load Capacity",
            "load_capacity_unit_of_measure" => "Load Capacity Unit Of Measure",
            "capacity_name" => "Number of Horses",
            "specific_uses_for_product" => "Specific Uses For Product",
            "compatible_devices" => "Compatible Devices",
            "maximum_weight_recommendation" => "Weight Supported",
            "maximum_weight_recommendation_unit_of_measure" => "Maximum Weight Recommendation Unit Of Measure",
            "maximum_weight_capacity" => "Maximum Weight",
            "maximum_weight_capacity_unit_of_measure" => "Maximum Weight Capacity Unit Of Measure",
            "unit_count_type" => "Unit Count Type",
            "batteries_required" => "Are Batteries Required",
            "battery_type" => "Battery Type",
            "number_of_batteries" => "Number of Batteries Required",
            "battery_average_life" => "Battery Average Life",
            "lithium_battery_packaging" => "Lithium Battery Packaging",
            "lithium_battery_weight" => "Lithium Battery Weight",
            "wheelbase" => "Wheelbase",
            "wheelbase_unit_of_measure" => "Unit of Measure for Wheelbase",
            "wheel_type" => "Wheel Type",
            "water_resistance_level" => "Water Resistance Level",
            "warranty_description" => "Warranty Description",
            "shell_type" => "Shell Type",
            "recommended_uses_for_product" => "Recommended Use",
            "magnification_strength" => "Magnification Strength",
            "lining_description" => "Lining Description",
            "base_material_type" => "Base",
            "unit_count" => "Unit Count",
            "lithium_battery_weight_unit_of_measure" => "Unit of measure of lithium battery weight",
        );
        return $attributes;
    }
    public function amazon_officeAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "feed_product_type" => "Product Type",
            "item_name" => "Product Name",
            "brand_name" => "Brand Name",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "product_description" => "Product Description",
            "item_type" => "Category (item-type)",
            "update_delete" => "Update Delete",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "item_package_quantity" => "Package Quantity",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "standard_price" => "Standard Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "quantity" => "Quantity",
            "fulfillment_latency" => "Fulfillment Latency",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "missing_keyset_reason" => "Registered Parameter",
            "max_order_quantity" => "Max Order Quantity",
            "merchant_shipping_group_name" => "Shipping-Template",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_height" => "Item Height",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords" => "Target Audience",
            "thesaurus_subject_keywords" => "Subject Matter",
            "catalog_number" => "Catalog Number",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_length" => "Package Length",
            "package_width" => "Package Width",
            "package_height" => "Package Height",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "prop_65" => "Prop 65",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "power_source_type" => "Power Source",
            "special_features" => "Additional Features",
            "battery_type" => "Battery Type",
            "radio_bands_supported" => "Telephone Frequency",
            "color_name" => "Colour",
            "color_map" => "Colour Map",
            "number_of_batteries" => "Number of Batteries Required",
            "display_type" => "Display Type",
            "display_technology" => "Display Technology",
            "size_name" => "Size",
            "maximum_size" => "maximum-expandable-size",
            "maximum_size_unit_of_measure" => "Maximum Size Unit Of Measure",
            "line_size" => "Line Size",
            "line_size_unit_of_measure" => "Line Size Unit Of Measure",
            "paper_size" => "paper-size",
            "size_map" => "Size Map",
            "paper_size_unit_of_measure" => "Paper Size Unit of Measure",
            "connectivity_technology" => "Printer Connectivity Type",
            "printer_technology" => "Printer Type",
            "printer_output" => "Printer Output Type",
            "max_printspeed_color" => "Color Pages per Minute�",
            "max_printspeed_black_white" => "B&W Pages per Minute",
            "ink_color" => "Ink Colour",
            "material_type" => "Material Type",
            "operating_system" => "Computer Platform",
            "paper_finish" => "Paper Finish",
            "brightness" => "Brightness",
        );
        return $attributes;
    }
    public function amazon_musicalinstrumentsAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "feed_product_type" => "Product Type",
            "item_type" => "Item Type Keyword",
            "brand_name" => "Brand",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "product_description" => "Product Description",
            "model" => "Model Number",
            "update_delete" => "Update Delete",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "product_tax_code" => "Product Tax Code",
            "item_package_quantity" => "Package Quantity",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "map_price" => "Minimum Advertised Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "standard_price" => "Standard Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "quantity" => "Quantity",
            "fulfillment_latency" => "Fulfillment Latency",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_height" => "Item Height",
            "item_width" => "Item Width",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "catalog_number" => "Catalog Number",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords" => "Target Audience",
            "thesaurus_subject_keywords" => "Subject Matter",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_length" => "Package Length",
            "package_width" => "Package Width",
            "package_height" => "Package Height",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "country_string" => "Country of Origin",
            "region_of_origin" => "Region of Origin",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "material_type" => "Material Type",
            "special_features" => "Additional Features",
            "model_year" => "Model Year",
            "model_name" => "Model Name",
            "musical_style" => "Musical Style",
            "instrument_key" => "Instrument Key",
            "range" => "Range",
            "polar_pattern" => "Polar Pattern",
            "body_material_type" => "Body Material Type",
            "string_material_type" => "String Material Type",
            "string_gauge" => "String Gauge",
            "number_of_keys" => "Number of Keys",
            "number_of_channels" => "Number of Channels",
            "output_wattage" => "Output Wattage",
            "speaker_amplification_type" => "Speaker Amplification Type",
            "number_of_strings" => "Number of Strings",
            "hand_orientation" => "Hand Orientation",
            "guitar_bridge_system" => "Guitar Bridge System",
            "guitar_pickup_configuration" => "Guitar Pickup Configuration",
            "size_name" => "Size",
            "guitar_pick_thickness" => "Guitar Pick Thickness",
            "included_components" => "Included components",
            "size_map" => "Size Map",
            "is_memorabilia" => "Is Memorabilia",
            "is_autographed" => "Is Autographed",
            "platinum_keywords1" => "Platinum Keywords1",
            "platinum_keywords2" => "Platinum Keywords2",
            "platinum_keywords3" => "Platinum Keywords3",
            "platinum_keywords4" => "Platinum Keywords4",
            "platinum_keywords5" => "Platinum Keywords5",
            "rebate_start_at1" => "Rebate Start Date1",
            "rebate_start_at2" => "Rebate Start Date2",
            "rebate_end_at1" => "Rebate End Date1",
            "rebate_end_at2" => "Rebate End Date2",
            "rebate_description1" => "Rebate Message1",
            "rebate_description2" => "Rebate Message2",
            "rebate_name1" => "Rebate1",
            "rebate_name2" => "Rebate2",
            "mixer_channel_quantity" => "Mixer Channel Quantity",
            "speaker_size_unit_of_measure" => "Speaker Size Unit Of Measure",
            "speaker_size" => "Speaker Size",
            "speaker_count" => "Speaker Count",
            "recorder_track_count" => "Recorder Track Count",
            "wireless_microphone_frequency_unit_of_measure" => "Wireless Microphone Frequency Unit Of Measure",
            "wireless_microphone_frequency" => "Wireless Microphone Frequency",
            "signal_format" => "Signal Format",
            "supported_software" => "Supported Software",
            "currency" => "Currency",
            "delivery_schedule_group_id" => "Scheduled Delivery SKU List",
        );
        return $attributes;
    }
    public function amazon_homeimprovementAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "brand_name" => "Brand Name",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "product_description" => "Product Description",
            "feed_product_type" => "Product Type",
            "item_type" => "Item Type Keyword",
            "update_delete" => "Update Delete",
            "standard_price" => "Standard Price",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "quantity" => "Quantity",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "map_price" => "Minimum Advertised Price",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "product_tax_code" => "Product Tax Code",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "item_package_quantity" => "Package Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued By Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "item_height" => "Item Height",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_display_weight" => "Item Display Weight",
            "item_display_weight_unit_of_measure" => "Item Display Weight Unit Of Measure",
            "item_display_height" => "Item Display Height",
            "item_display_height_unit_of_measure" => "Item Display Height Unit Of Measure",
            "item_display_length" => "Item Display Length",
            "item_display_length_unit_of_measure" => "Item Display Length Unit Of Measure",
            "item_display_width" => "Item Display Width",
            "item_display_width_unit_of_measure" => "Item Display Width Unit Of Measure",
            "catalog_number" => "Catalog Number",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords1" => "Target Audience1",
            "target_audience_keywords2" => "Target Audience2",
            "thesaurus_subject_keywords" => "Subject Matter",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "swatch_image_url" => "Swatch Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "prop_65" => "Prop 65",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "country_of_origin" => "Country of Origin",
            "lighting_facts_image_url" => "Lighting Facts Label",
            "energy_efficiency_image_url" => "Energy Guide Label",
            "fabric_type" => "Fabric Type",
            "import_designation" => "Import Designation",
            "legal_compliance_certification_metadata" => "Please provide the Executive Number (EO) required for sale into California.",
            "legal_compliance_certification_expiration_date" => "Please provide the expiration date of the EO Number.",
            "warranty_type" => "Warranty Type",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "size_name" => "Size",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "style_name" => "Style Name",
            "material_type" => "Material Type",
            "pattern_name" => "Design",
            "item_shape" => "Shape",
            "horsepower" => "Horsepower",
            "power_source_type" => "Power Source",
            "voltage" => "Voltage",
            "wattage" => "Wattage",
            "included_components" => "Included Components",
            "special_features" => "Additional Features",
            "specific_uses_for_product" => "Specific Uses For Product",
            "water_consumption" => "Water Consumption",
            "water_consumption_unit_of_measure" => "Water Consumption Unit Of Measure",
            "installation_type" => "Installation Method",
            "controller_type" => "Controller Type",
            "connectivity_protocol" => "Connectivity Protocol",
            "maximum_pressure" => "Maximum Pressure",
            "number_of_pieces" => "Number of Pieces",
            "handle_location" => "Handle Lever Placement",
            "number_of_handles" => "Number Of Handles",
            "specification_met" => "Energy Specifications Met",
            "light_source_type" => "Light Source Type",
            "brightness" => "Brightness",
            "minimum_efficiency_reporting_value" => "Minimum Efficiency Reporting Values",
            "number_of_basins" => "number-of-basins",
            "inside_diameter_string" => "Inside Diameter",
            "blade_edge_type" => "Blade Edge",
            "item_pitch_string" => "Pitch",
            "item_torque" => "Torque",
            "item_torque_unit_of_measure" => "Item Torque Unit Of Measure",
            "point_type" => "Tool Tip Description",
            "measurement_system" => "System of Measurement",
            "measurement_accuracy" => "Measurement Accuracy",
            "grit_type" => "Grit Type",
            "display_type" => "Display",
            "mounting_type" => "Mounting Type",
            "switch_type" => "Switch Style",
            "unit_count_type" => "Unit Count Type",
            "battery_cell_composition" => "Battery Cell Type",
            "lithium_battery_weight" => "Lithium Battery Weight",
            "size_map" => "Size Map",
            "unit_count" => "Unit Count",
            "wattage_unit_of_measure" => "Wattage Unit of Measure",
            "lithium_battery_weight_unit_of_measure" => "Unit of measure of lithium battery weight",
            "inside_diameter_unit_of_measure" => "Inside Diameter Unit Of Measure",
            "color_temperature" => "Color Temperature",
            "currency" => "Currency",
            "seller_warranty_description" => "Seller Warranty Description",
            "platinum_keywords1" => "Platinum Keywords1",
            "platinum_keywords2" => "Platinum Keywords2",
            "platinum_keywords3" => "Platinum Keywords3",
            "platinum_keywords4" => "Platinum Keywords4",
            "platinum_keywords5" => "Platinum Keywords5",
            "finish_type" => "Finish Types",
            "item_thickness_derived" => "Thickness Derived",
            "item_thickness_unit_of_measure" => "Item Thickness Unit Of Measure",
            "maximum_current" => "Amperage Capacity",
            "temperature_range_base" => "Temperature Range Base",
            "temperature_range_unit_of_measure" => "Temperature Range Unit Of Measure",
            "maximum_flow_rate" => "Flow Rate",
            "maximum_flow_rate_unit_of_measure" => "Maximum Flow Rate Unit Of Measure",
            "air_flow_capacity" => "Air Flow Capacity",
            "maximum_weight_capacity" => "Maximum Weight Capacity",
            "maximum_weight_capacity_unit_of_measure" => "Maximum Weight Capacity Unit Of Measure",
            "capacity_name" => "Capacity Description",
            "noise_level" => "Noise",
            "noise_level_unit_of_measure" => "Noise Level Unit Of Measure",
            "extension_length" => "Extension Length",
            "extension_length_unit_of_measure" => "Extension Length Unit Of Measure",
            "hose_length" => "Hose Length",
            "hose_length_unit_of_measure" => "Hose Length Unit Of Measure",
            "strand_diameter" => "Cord Length",
            "strand_diameter_unit_of_measure" => "Strand Diameter Unit Of Measure",
            "screw_head_style" => "Head Style",
            "handle_material" => "Handle Material",
            "blade_length" => "Blade Length",
            "blade_length_unit_of_measure" => "Blade Length Unit Of Measure",
            "folded_size" => "Folded Size",
            "speed" => "Speed",
            "speed_rating" => "Performance Description",
            "maximum_power" => "Maximum Power",
            "maximum_power_unit_of_measure" => "Maximum Power Unit Of Measure",
            "cutting_diameter" => "Cutting Diameter",
            "cutting_diameter_unit_of_measure" => "Cutting Diameter Unit Of Measure",
            "fastening_type" => "Accessory Connection Type",
            "compatible_fastener_description" => "Compatible Fastener Range",
            "laser_color" => "Laser Beam Color",
            "viewable_area" => "Viewing Area",
            "ultraviolet_light_protection" => "UV Protection",
            "grit_number" => "Grit Number",
            "coverage" => "Coverage",
            "item_diameter_derived" => "Outside Diameter Derived",
            "item_diameter_unit_of_measure" => "Item Diameter Unit Of Measure",
            "are_batteries_included" => "Are Batteries Included",
            "batteries_required" => "Are Batteries Required",
            "battery_description" => "Supported Battery Types",
            "battery_average_life" => "Battery Average Life",
            "battery_average_life_unit_of_measure" => "Battery Average Life Unit Of Measure",
            "lithium_battery_energy_content" => "Lithium Battery Energy Content",
            "lithium_battery_packaging" => "Lithium Battery Packaging",
            "lithium_battery_voltage" => "Lithium Battery Voltage",
            "number_of_lithium_ion_cells" => "Number of Lithium-ion Cells",
            "number_of_lithium_metal_cells" => "Number of Lithium Metal Cells",
            "tubing_outside_diameter" => "Tube Outside Diameter",
            "tubing_outside_diameter_unit_of_measure" => "Tube Outside Diameter Unit of Measure",
            "delivery_schedule_group_id" => "Scheduled Delivery SKU List",
            "item_display_diameter" => "Item Display Diameter",
            "item_display_diameter_unit_of_measure" => "Item Display Diameter Unit Of Measure",
            "grip_type" => "grip_type",
        );
        return $attributes;
    }
    public function amazon_entertainmentcollectiblesAttributes (){
        $attributes = array(
            "item_name" => "Product Name",
            "item_type" => "Category (item-type)",
            "item_sku" => "Seller SKU",
            "product_description" => "Product Description",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "update_delete" => "Update Delete
",
            "standard_price" => "Your price",
            "quantity" => "Quantity",
            "product_site_launch_date" => "Launch Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "product_tax_code" => "Product Tax Code",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "restock_date" => "Restock Date",
            "condition_note" => "Condition Note",
            "minimum_accept_percentage" => "Make an Offer Auto-Accept Threshold",
            "merchant_shipping_group_name" => "Shipping-Template",
            "maximum_reject_percentage" => "Make an Offer Auto-Reject Threshold",
            "make_an_offer_eligibility" => "Make an Offer Eligible",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Height",
            "package_width" => "Width",
            "package_length" => "Length",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit of Measure",
            "package_weight" => "Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parent/Child",
            "parent_sku" => "Parent Sku",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "style_name" => "Entertainment Type",
            "genre" => "genre",
            "originality" => "Collectible Type",
            "authenticated_by" => "Authenticity By",
            "graded_by" => "Grading By",
            "grade_rating" => "Grade",
            "is_autographed" => "Is Autographed",
            "is_adult_product" => "Adult Product",
            "model_year" => "Model Year",
            "theme" => "theme",
            "additional_product_information" => "Product Type",
            "special_features" => "Additional Features",
            "limited_edition_quantity" => "Limited Edition Quantity",
            "card_number" => "Card Number",
            "material_type1" => "Frame Type1",
            "material_type2" => "Frame Type2",
            "material_type3" => "Frame Type3",
            "material_type4" => "Frame Type4",
            "material_type5" => "Frame Type5",
            "material_type6" => "Frame Type6",
            "material_type7" => "Frame Type7",
            "material_type8" => "Frame Type8",
            "material_type9" => "Frame Type9",
            "material_type10" => "Frame Type10",
            "size_name" => "Size Name",
            "size_map" => "size_map",
        );
        return $attributes;
    }
    public function amazon_ConsumerElectronicsAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Title",
            "brand_name" => "Brand",
            "manufacturer" => "Manufacturer",
            "product_description" => "Description",
            "item_type" => "Item Type",
            "feed_product_type" => "Product Type",
            "part_number" => "Mfr Part Number",
            "model" => "Model Number",
            "update_delete" => "Update Delete",
            "max_order_quantity" => "Max Order Quantity",
            "standard_price" => "Standard Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "quantity" => "Quantity",
            "condition_type" => "Item Condition",
            "condition_note" => "Condition Note",
            "map_price" => "Minimum Advertised Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Maximum Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued By Manufacturer",
            "missing_keyset_reason" => "Registered Parameter",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_height" => "Item Height",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "bullet_point1" => "Bullet Point1",
            "bullet_point2" => "Bullet Point2",
            "bullet_point3" => "Bullet Point3",
            "bullet_point4" => "Bullet Point4",
            "bullet_point5" => "Bullet Point5",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "country_of_origin" => "Country of Origin",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "prop_65" => "Prop 65",
            "safety_warning" => "Warnings",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "energy_efficiency_image_url" => "Energy Guide Label",
            "mounting_type" => "Mount Type",
            "battery_cell_composition" => "Battery Cell Type",
            "battery_average_life" => "Battery Average Life",
            "battery_average_life_unit_of_measure" => "Battery Average Life Unit Of Measure",
            "lithium_battery_energy_content" => "Lithium-Battery Energy Content",
            "lithium_battery_packaging" => "Lithium-Battery Packaging",
            "lithium_battery_voltage" => "Lithium-Battery Voltage",
            "write_speed" => "Media Speed",
            "vehicle_speaker_size" => "Vehicle Speaker Size",
            "enclosure" => "Enclosure",
            "supported_standards" => "Supported Standards",
            "map_type" => "Map Types",
            "gps_navigation" => "GPS Geotagging Functionality",
            "hard_disk_size" => "Hard-Drive Size",
            "hard_disk_size_unit_of_measure" => "Hard Disk Size Unit Of Measure",
            "memory_slots_available" => "Memory Slots Available",
            "computer_memory_size" => "RAM Size",
            "computer_memory_size_unit_of_measure" => "Computer Memory Size Unit Of Measure",
            "computer_cpu_speed" => "Processor Speed",
            "computer_cpu_speed_unit_of_measure" => "Computer Cpu Speed Unit Of Measure",
            "computer_cpu_type" => "Processor Series",
            "fit_type" => "Headphone Fit",
            "audio_sensitivity" => "Audio Sensitivity",
            "microphone_technology" => "MicrophoneTechnology",
            "power_source_type" => "Power Source",
            "connector_gender" => "Connector Gender",
            "water_resistance_level" => "Water Resistance Level",
            "surround_sound_channel_configuration" => "Number of Audio Channels",
            "cooling_method" => "Cooling Method",
            "computer_cpu_manufacturer" => "Processor Brand",
            "operating_system" => "Operating System",
            "human_interface_input" => "Human-Interface Input",
            "frequency_response_curve" => "Frequency Response Curve",
            "specification_met" => "Energy Specifications Met",
            "material_type" => "Enclosure Material",
            "item_shape" => "Shape",
            "speaker_connectivity" => "Speaker Connectivity",
            "tuner_technology" => "Tuner Type",
            "hardware_platform" => "Hardware Platform",
            "input_device_interface" => "Input-Device Interface",
            "screen_surface_description" => "Screen Finish",
            "display_size" => "Screen Size",
            "display_size_unit_of_measure" => "Display Size Unit Of Measure",
            "native_resolution" => "Native Resolution",
            "image_contrast_ratio" => "Contrast Ratio",
            "wireless_comm_standard" => "Wireless Compability",
            "supported_internet_services" => "Internet Applications",
            "output_wattage" => "Output Wattage",
            "connectivity_technology" => "Connectivity Technology",
            "data_transfer_rate" => "Data Transfer Rate",
            "data_transfer_rate_unit_of_measure" => "Data Transfer Rate Unit Of Measure",
            "image_brightness" => "Brightness",
            "image_brightness_unit_of_measure" => "Image Brightness Unit Of Measure",
            "maximum_image_size" => "Maximum Image Size",
            "min_focal_length" => "Minimum Focal Length",
            "zoom_type" => "Zoom",
            "speaker_type" => "Speaker Type",
            "wireless_communication_technology" => "Wireless Technology",
            "display_type" => "Display Type",
            "included_components" => "Built-In Media",
            "total_hdmi_ports" => "Total Number of HDMI Ports",
            "special_features" => "Additional Features",
            "number_of_batteries" => "Number of Batteries Required",
            "battery_type" => "Battery Type",
            "mfg_warranty_description_type" => "Manufacturer Warranty Type",
            "mfg_warranty_description_parts" => "Lamp Warranty",
        );
        return $attributes;
    }
    public function amazon_computersAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Title",
            "brand_name" => "Brand",
            "manufacturer" => "Manufacturer",
            "product_description" => "Description",
            "item_type" => "Item Type",
            "feed_product_type" => "Product Type",
            "part_number" => "Mfr Part Number",
            "model" => "Model Number",
            "update_delete" => "Update Delete",
            "standard_price" => "Standard Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "quantity" => "Quantity",
            "condition_type" => "Item Condition",
            "condition_note" => "Condition Note",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "number_of_items" => "Number of Items",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Maximum Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued By Manufacturer",
            "minimum_accept_percentage" => "Make an Offer Auto-Accept Threshold",
            "merchant_shipping_group_name" => "Shipping-Template",
            "maximum_reject_percentage" => "Make an Offer Auto-Reject Threshold",
            "make_an_offer_eligibility" => "Make an Offer Eligible",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_height" => "Item Height",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "bullet_point1" => "Bullet Point1",
            "bullet_point2" => "Bullet Point2",
            "bullet_point3" => "Bullet Point3",
            "bullet_point4" => "Bullet Point4",
            "bullet_point5" => "Bullet Point5",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "swatch_image_url" => "Swatch Image URL",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "country_of_origin" => "Country of Origin",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "prop_65" => "Prop 65",
            "safety_warning" => "Warnings",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "number_of_ports" => "Number of Ports",
            "wattage" => "Wattage",
            "hardware_interface" => "Hardware Connectivity",
            "power_source_type" => "Power Source",
            "battery_average_life" => "Battery Average Life",
            "lithium_battery_energy_content" => "Lithium-Battery Energy Content",
            "lithium_battery_packaging" => "Lithium-Battery Packaging",
            "lithium_battery_voltage" => "Lithium-Battery Voltage",
            "lithium_battery_weight" => "Lithium Battery Weight",
            "lithium_battery_weight_unit_of_measure" => "Lithium Battery Weight  Unit Of Measure",
            "mfg_warranty_description_type" => "Manufacturer Warranty Type",
            "mfg_warranty_description_parts" => "Lamp Warranty",
            "computer_memory_size" => "RAM Size",
            "computer_cpu_manufacturer" => "Processor Brand",
            "computer_cpu_speed" => "Processor Speed",
            "computer_cpu_speed_unit_of_measure" => "Processor Speed Unit Of Measure",
            "processor_count" => "Processor Count",
            "graphics_ram_type" => "Graphics Ram Type",
            "graphics_coprocessor" => "Graphics Coprocessor",
            "computer_memory_size_unit_of_measure" => "Computer Memory Size Unit Of Measure",
            "system_ram_type" => "RAM Type",
            "model_name" => "Model Name",
            "wireless_communication_technology" => "Wireless Technology",
            "human_interface_input" => "Human-Interface Input",
            "computer_cpu_type" => "Processor Series",
            "native_resolution" => "Native Resolution",
            "display_resolution_maximum" => "Display Resolution Maximum",
            "display_size" => "Screen Size",
            "display_size_unit_of_measure" => "Display Size Unit Of Measure",
            "tuner_technology" => "Tuner Type",
            "photo_sensor_resolution" => "Max Webcam Image Resolution",
            "photo_sensor_resolution_unit_of_measure" => "Photo Sensor Resolution Unit Of Measure",
            "hard_disk_rotational_speed" => "Hard Disk Rotational Speed",
            "hardware_platform" => "Hardware Platform",
            "hard_disk_description" => "Hard Disk Description",
            "hard_disk_size" => "Hard-Drive Size",
            "graphics_ram" => "Graphics Card Ram",
            "graphics_processor_manufacturer" => "Video Processor",
            "memory_clock_speed" => "EffectiveMemoryClock",
            "memory_clock_speed_unit_of_measure" => "Memory Clock Speed Unit Of Measure",
            "processor_socket" => "Processor Socket",
            "ram_memory_technology" => "RAM Memory Technology",
            "hard_disk_interface" => "Hard Disk Interface",
            "total_hdmi_ports" => "Total Number of HDMI Ports",
            "form_factor" => "Form Factor",
            "total_usb_2_0_ports" => "USB 2.0",
            "wireless_comm_standard" => "Wireless Compability",
            "hard_drive_size_unit_of_measure" => "Hard Drive Size Unit Of Measure",
            "secure_digital_association_speed_class" => "Secure Digital Association Speed Class",
            "write_speed_unit_of_measure" => "Write Speed Unit Of Measure",
            "gps_navigation" => "GPS Geotagging Functionality",
            "write_speed" => "Media Speed",
            "special_features" => "Additional Features",
            "memory_storage_capacity" => "Memory Storage Capacity",
            "memory_storage_capacity_unit_of_measure" => "Memory Storage Capacity Unit Of Measure",
            "display_technology" => "Display Technology",
            "image_contrast_ratio" => "Contrast Ratio",
            "image_brightness" => "Brightness",
            "image_brightness_unit_of_measure" => "Image Brightness Unit Of Measure",
            "cooling_method" => "Cooling Method",
            "light_type" => "Light Type",
            "memory_slots_available" => "Memory Slots Available",
            "number_of_pins" => "SSD Connector Pins",
            "operating_system" => "Operating System",
            "memory_bus_width" => "Memory Bus Width",
            "memory_bus_width_unit_of_measure" => "Memory Bus Width Unit Of Measure",
            "maximum_image_size" => "Maximum Image Size",
            "zoom_type" => "Zoom",
            "image_aspect_ratio" => "Image Aspect Ration",
            "remote_control_description" => "Remote Control Description",
            "max_horizontal_resolution" => "Maximum horizontal resolution",
            "capacity_name" => "capacity_name",
            "included_components" => "Built-In Media",
            "specific_uses_for_product" => "Specific Uses For Product",
            "photo_sensor_technology" => "Photo Sensor Technology",
            "effective_still_resolution" => "Effective Still Resolution",
            "effective_still_resolution_unit_of_measure" => "Effective Still Resolution Unit Of Measure",
            "output_wattage" => "Output Wattage",
            "output_channel_quantity" => "Output Channel Quantity",
            "surround_sound_channel_configuration" => "Number of Audio Channels",
            "speakers_maximum_output_power" => "Speaker Maximum Output Power",
            "connectivity_technology" => "Connectivity Technology",
            "radio_bands_supported" => "Radio Bands Supported",
            "material_type" => "Enclosure Material",
            "compatible_devices" => "Compatible Devices",
            "frequency_response_curve" => "Frequency Response Curve",
            "supported_motherboard" => "Supported Motherboard",
            "speaker_connectivity" => "Speaker Connectivity",
            "hard_disk_form_factor" => "Hard Disk Form Factor",
            "flash_memory_type" => "Flash Memory Type",
            "data_transfer_rate" => "Data Transfer Rate",
        );
        return $attributes;
    }
    public function amazon_CameraAndPhotoAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Title",
            "brand_name" => "Brand",
            "manufacturer" => "Manufacturer",
            "product_description" => "Description",
            "item_type" => "Item Type",
            "feed_product_type" => "Product Type",
            "part_number" => "Mfr Part Number",
            "model" => "Model Number",
            "update_delete" => "Update Delete",
            "standard_price" => "Standard Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "quantity" => "Quantity",
            "max_order_quantity" => "Max Order Quantity",
            "condition_type" => "Item Condition",
            "condition_note" => "Condition Note",
            "map_price" => "Minimum Advertised Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Maximum Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued By Manufacturer",
            "missing_keyset_reason" => "Registered Parameter",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_height" => "Item Height",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "bullet_point1" => "Bullet Point1",
            "bullet_point2" => "Bullet Point2",
            "bullet_point3" => "Bullet Point3",
            "bullet_point4" => "Bullet Point4",
            "bullet_point5" => "Bullet Point5",
            "generic_keywords" => "Search Terms",
            "style_keywords" => "Style-specific Terms",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "country_of_origin" => "Country of Origin",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "prop_65" => "Prop 65",
            "safety_warning" => "Warnings",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "number_of_batteries" => "Number of Batteries Required",
            "battery_type" => "BatteryType",
            "battery_cell_composition" => "Battery Cell Type",
            "mfg_warranty_description_type" => "Manufacturer Warranty Type",
            "mfg_warranty_description_parts" => "Manufacturer Parts Warranty",
            "alarm_clock" => "Alarm Clock",
            "compatible_mountings" => "Compatible Camera Mount",
            "optical_sensor_technology" => "Image Sensor Type",
            "media_format_digital_video" => "Media Storage",
            "mounting_type" => "Mounting Type",
            "included_components" => "Number of Included Cameras",
            "remote_control_description" => "Remote",
            "signal_format" => "Signal Type",
            "video_capture_resolution" => "Video Resolution",
            "wireless_communication_technology" => "Wireless Technology",
            "special_features" => "Features",
            "digital_zoom" => "Digital Zoom",
            "includes_external_memory" => "External Memory Included",
            "focus_description" => "Focus Features",
            "gps_navigation" => "Geotagging or GPS Functionality",
            "supported_image_type" => "Image Format",
            "computer_memory_size" => "Internal Memory Size",
            "ram_memory_technology" => "Internal Memory Type",
            "monitor_size" => "LCD Screen Size",
            "monitor_size_unit_of_measure" => "Monitor Size Unit Of Measure",
            "photo_sensor_technology" => "Sensor Type",
            "total_hdmi_ports" => "Total Number of HDMI Ports",
            "total_usb_2_0_ports" => "Total USB 2.0 Ports",
            "total_usb_3_0_ports" => "Total USB 3.0 Ports",
            "human_interface_input" => "Touchscreen",
            "iso_range" => "ISO Range",
            "optical_zoom" => "Optical Zoom",
            "min_focal_length" => "Minimum Focal Length",
            "water_resistance_level" => "Water Resistance Level",
            "lens_type" => "Lens Type",
            "platform" => "Computer Platform",
            "max_aperture" => "Maximum Aperture",
            "max_focal_length" => "Maximum Focal Length",
            "min_aperture" => "Minimum Aperture",
            "viewfinder_type" => "Viewfinder Type",
            "film_lighting_type" => "Lighting Type",
            "specific_uses_for_product" => "Specific Uses",
            "photo_filter_mount_type" => "Mount Type",
            "photo_filter_thread_size" => "Thread Size",
            "photo_filter_effect_type" => "Special Effect",
            "included_flash_type" => "Flash Type",
            "flash_dedication" => "Flash Dedication",
            "objective_lens_diameter" => "Objective Lens Diameter",
            "real_angle_of_view" => "Real Angle of View",
            "focus_type" => "Focus Type",
            "film_format_type" => "Film Format",
            "continuous_shooting_speed" => "Continuous Shooting",
            "exposure_control_type" => "Exposure Control",
            "flash_modes_description" => "Flash Modes",
            "macro_focus_range" => "Macro Focus",
            "max_shutter_speed" => "Maximum Shutter Speed",
            "min_shutter_speed" => "Minimum Shutter Speed",
            "metering_description" => "Metering Methods",
            "size_name" => "Size",
            "specification_met" => "Outdoor Use",
            "display_size" => "Display Size",
            "zoom_type" => "Focal Type",
            "tripod_head_type" => "Head Type",
            "material_type" => "Material Type",
            "power_source_type" => "Power Source",
            "telescope_mount_description" => "Mount",
        );
        return $attributes;
    }

    public function amazon_BookLoaderAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Title",
            "manufacturer" => "Publisher",
            "product_description" => "Product Description",
            "update_delete" => "Update Delete",
            "author" => "Author",
            "binding" => "Binding",
            "publication_date" => "Publication date",
            "edition" => "Edition Number",
            "standard_price" => "Standard Price",
            "quantity" => "Quantity",
            "merchant_shipping_group_name" => "Shipping-Template",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "product_tax_code" => "Product Tax Code",
            "expedited_shipping" => "Expedited Shipping",
            "will_ship_internationally" => "Will Ship Internationally",
            "standard_plus" => "Standard Plus",
            "delivery_schedule_group_id" => "Scheduled Delivery SKU List",
            "generic_keywords1" => "Search Terms1",
            "generic_keywords2" => "Search Terms2",
            "generic_keywords3" => "Search Terms3",
            "generic_keywords4" => "Search Terms4",
            "generic_keywords5" => "Search Terms5",
            "main_image_url" => "Main Image URL",
            "main_offer_image" => "Main Offer Image",
            "offer_image1" => "Offer Image1",
            "offer_image2" => "Offer Image2",
            "offer_image3" => "Offer Image3",
            "offer_image4" => "Offer Image4",
            "offer_image5" => "Offer Image5",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "unknown_subject" => "Subject",
            "illustrator" => "Illustrator",
            "pages" => "Pages",
            "series_number" => "Number in Series",
            "collection_name" => "Series Title",
            "editor" => "Editor",
            "preface" => "Preface",
            "colorist" => "Colorist",
            "compiler" => "Compiler",
            "composer1" => "Composer1",
            "composer2" => "Composer2",
            "composer3" => "Composer3",
            "composer4" => "Composer4",
            "composer5" => "Composer5",
            "composer6" => "Composer6",
            "composer7" => "Composer7",
            "composer8" => "Composer8",
            "composer9" => "Composer9",
            "composer10" => "Composer10",
            "creator" => "Creator",
            "drawings" => "Drawings",
            "painter" => "Painter",
            "reader" => "Reader",
            "series_editor" => "Series Editor",
            "technical_editor" => "Technical editor",
            "adapter" => "Adapter",
            "afterword" => "Afterword",
            "artist1" => "Artist1",
            "artist2" => "Artist2",
            "artist3" => "Artist3",
            "artist4" => "Artist4",
            "artist5" => "Artist5",
            "artist6" => "Artist6",
            "artist7" => "Artist7",
            "artist8" => "Artist8",
            "artist9" => "Artist9",
            "artist10" => "Artist10",
            "foreword" => "Foreword",
            "introduction" => "Introduction",
            "translator" => "Translator",
            "photographer" => "Photographer",
            "format1" => "Format1",
            "format2" => "Format2",
            "format3" => "Format3",
            "format4" => "Format4",
            "format5" => "Format5",
            "format6" => "Format6",
            "format7" => "Format7",
            "format8" => "Format8",
            "format9" => "Format9",
            "format10" => "Format10",
            "dust_jacket_description" => "Dust Jacket Condition",
            "signed_by" => "Signed By",
        );
        return $attributes;
    }
    public function amazon_tiresandwheelsAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "brand_name" => "Brand",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "product_description" => "Product Description",
            "feed_product_type" => "Product Type",
            "item_type" => "Item Type Keyword",
            "update_delete" => "Update Delete",
            "item_package_quantity" => "Package Quantity",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "map_price" => "Minimum Advertised Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "standard_price" => "Standard Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "quantity" => "Quantity",
            "fulfillment_latency" => "Production Time",
            "max_aggregate_ship_quantity" => "Maximum Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_height" => "Item Height",
            "item_width" => "Item Width",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "catalog_number" => "Merchant Catalog Number",
            "bullet_point1" => "Bullet Point1",
            "bullet_point2" => "Bullet Point2",
            "bullet_point3" => "Bullet Point3",
            "bullet_point4" => "Bullet Point4",
            "bullet_point5" => "Bullet Point5",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords" => "Target Audience",
            "thesaurus_subject_keywords" => "Subject Matter",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "part_type_id" => "Part Type ID",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "model_name" => "Series",
            "rim_size" => "Bike Rim Size",
            "rim_size_unit_of_measure" => "Rim Size Unit Of Measure",
            "compatible_with_vehicle_type" => "Vehicle Service Type",
            "load_index" => "Load Index",
            "speed_rating" => "Performance Description",
            "uniform_tire_quality_grade_rating" => "UTQG Rating",
            "section_width" => "Section Width",
            "section_width_unit_of_measure" => "Tyre Section Width Unit of Measure",
            "tire_aspect_ratio" => "Tire Aspect Ratio",
            "tire_aspect_ratio_unit_of_measure" => "Tire Aspect Ratio Unit Of Measure",
            "tread_depth" => "Tread Depth",
            "tread_depth_unit_of_measure" => "Tread Depth Unit Of Measure",
            "pitch_circle_diameter1" => "Pitch Circle Diameter1",
            "pitch_circle_diameter2" => "Pitch Circle Diameter2",
            "construction_type" => "Mechanical Structure",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "exterior_finish" => "Body Part Exterior Finish",
            "exterior_finish_map" => "exterior-finish-map",
            "special_features" => "Additional Features",
            "hole_count" => "Hole Count",
            "number_of_spokes" => "Number Of Spokes",
            "wheel_backspacing" => "Wheel Backspacing",
            "wheel_backspacing_unit_of_measure" => "Wheel Backspacing Unit Of Measure",
            "rim_width" => "Rim Width",
            "rim_width_unit_of_measure" => "Rim Width Unit Of Measure",
            "item_offset" => "Offset",
            "item_offset_unit_of_measure" => "Item Offset Unit Of Measure",
            "pitch_circle_diameter_unit_of_measure" => "Pitch Circle Diameter Unit Of Measure",
        );
        return $attributes;
    }
    public function amazon_autoaccessoryAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "feed_product_type" => "Product Type",
            "item_type" => "Item Type Keyword",
            "product_subtype" => "Clothing Type",
            "product_description" => "Product Description",
            "brand_name" => "Brand Name",
            "update_delete" => "Update Delete",
            "item_package_quantity" => "Package Quantity",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "map_price" => "Minimum Advertised Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "standard_price" => "Standard Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "quantity" => "Quantity",
            "fulfillment_latency" => "Fulfillment Latency",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "missing_keyset_reason" => "Registered Parameter",
            "merchant_shipping_group_name" => "Shipping-Template",
            "item_volume_unit_of_measure" => "Item Volume Unit Of Measure",
            "item_volume" => "Volume",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "item_length" => "Item Length",
            "item_height" => "Item Height",
            "item_width" => "Item Width",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "item_display_diameter_unit_of_measure" => "Item Display Diameter Unit Of Measure",
            "item_display_diameter" => "Diameter",
            "style_keywords" => "Style-specific Terms",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords" => "Target Audience",
            "generic_keywords" => "Search Terms",
            "catalog_number" => "Catalog Number",
            "thesaurus_subject_keywords" => "Subject Matter",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "swatch_image_url" => "Swatch Image URL",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_length" => "Package Length",
            "package_width" => "Package Width",
            "package_height" => "Package Height",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "country_of_origin" => "Country of Publication",
            "fabric_type" => "Fabric Type",
            "legal_compliance_certification_metadata" => "Please provide the Executive Number (EO) required for sale into California.",
            "legal_compliance_certification_expiration_date" => "Please provide the expiration date of the EO Number.",
            "exterior_finish" => "Body Part Exterior Finish",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "oe_manufacturer" => "OE Manufacturer",
            "part_interchange_info" => "Part Interchange Info",
            "department_name" => "Department",
            "model_name" => "Series",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "part_type_id" => "Part Type ID",
            "size_name" => "Size",
            "size_map" => "Size Map",
            "material_type" => "Material",
            "viscosity" => "Viscosity",
            "orientation" => "Orientation",
            "control_type" => "Mirror Adjustment",
            "light_type" => "Mirror Turn Signal Indicator",
            "special_features" => "Additional Features",
            "external_testing_certification" => "External Testing Certification",
            "light_source_type" => "Light Source Type",
            "operation_mode" => "Window Regulator Lift Type",
            "warranty_description" => "Manufacturer Warranty Description",
            "lifestyle" => "Occasion Lifestyle",
            "inner_material_type" => "Inner Material",
            "outer_material_type" => "Outer Material",
            "sole_material" => "Sole Material",
            "compatible_with_vehicle_type" => "Vehicle Type Compatibility",
            "voltage" => "Voltage",
            "wattage" => "Wattage",
            "amperage_unit_of_measure" => "Amperage Unit Of Measure",
            "amperage" => "Amperage",
            "mfg_warranty_description_type" => "Manufacturer Warranty Type",
            "abpa_partslink_number1" => "Partslink Number1",
            "abpa_partslink_number2" => "Partslink Number2",
            "abpa_partslink_number3" => "Partslink Number3",
            "abpa_partslink_number4" => "Partslink Number4",
        );
        return $attributes;
    }

    public function amazon_wirelessAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "item_name" => "Title",
            "manufacturer" => "Manufacturer",
            "item_type" => "Item Type",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "part_number" => "Manufacturing Part Number",
            "product_description" => "Description",
            "brand_name" => "Brand",
            "update_delete" => "Update Delete",
            "product_site_launch_date" => "Launch Date",
            "standard_price" => "Standard Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "condition_type" => "Item Condition",
            "condition_note" => "Condition Note",
            "product_tax_code" => "Product Tax Code",
            "merchant_release_date" => "Release Date",
            "map_price" => "Minimum Advertised Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "quantity" => "Quantity",
            "fulfillment_latency" => "Fulfillment Latency",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Maximum Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued By Manufacturer",
            "item_package_quantity" => "Package Quantity",
            "merchant_shipping_group_name" => "Shipping-Template",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_height" => "Item Height",
            "item_width" => "Item Width",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "bullet_point1" => "Bullet Point1",
            "bullet_point2" => "Bullet Point2",
            "bullet_point3" => "Bullet Point3",
            "bullet_point4" => "Bullet Point4",
            "bullet_point5" => "Bullet Point5",
            "generic_keywords" => "Search Terms",
            "target_audience_keywords1" => "Target Audience1",
            "target_audience_keywords2" => "Target Audience2",
            "target_audience_keywords3" => "Target Audience3",
            "catalog_number" => "Catalog Number",
            "specific_uses_keywords" => "Intended Use",
            "thesaurus_subject_keywords1" => "Subject Matter1",
            "thesaurus_subject_keywords2" => "Subject Matter2",
            "thesaurus_subject_keywords3" => "Subject Matter3",
            "thesaurus_subject_keywords4" => "Subject Matter4",
            "thesaurus_subject_keywords5" => "Subject Matter5",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "main_image_url" => "Main Image URL",
            "swatch_image_url" => "Swatch Image URL",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_length" => "Package Length",
            "package_width" => "Package Width",
            "package_height" => "Package Height",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "prop_65" => "Prop 65",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "fit_type" => "Headphone Fit",
            "special_features" => "Additional Features",
            "compatible_phone_models1" => "Compatible Phone Models1",
            "compatible_phone_models2" => "Compatible Phone Models2",
            "compatible_phone_models3" => "Compatible Phone Models3",
            "compatible_phone_models4" => "Compatible Phone Models4",
            "compatible_phone_models5" => "Compatible Phone Models5",
            "subject_keywords1" => "Subject Keywords1",
            "subject_keywords2" => "Subject Keywords2",
            "subject_keywords3" => "Subject Keywords3",
            "subject_keywords4" => "Subject Keywords4",
            "subject_keywords5" => "Subject Keywords5",
        );
        return $attributes;
    }
    public function amazon_babyAttributes (){
        $attributes = array(
            "item_sku" => "Seller SKU",
            "item_name" => "Title",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "feed_product_type" => "Product Type",
            "item_type" => "Item Type Keyword",
            "brand_name" => "Brand",
            "model" => "Model Number",
            "manufacturer" => "Manufacturer",
            "part_number" => "Part Number",
            "product_description" => "Description",
            "update_delete" => "Update Delete",
            "quantity" => "Quantity",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "map_price" => "Minimum Advertised Price",
            "standard_price" => "Standard Price",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "product_site_launch_date" => "Launch Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "number_of_items" => "Number of Items",
            "item_package_quantity" => "Item Package Quantity",
            "offering_end_date" => "Stop Selling Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "product_tax_code" => "Product Tax Code",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "missing_keyset_reason" => "Registered Parameter",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight" => "shipping-weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_height" => "Item Height",
            "item_width" => "item Width",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "item_display_weight" => "Display Weight",
            "item_display_weight_unit_of_measure" => "Item Display Weight Unit Of Measure",
            "item_display_volume" => "Display Volume",
            "item_display_volume_unit_of_measure" => "Item Display Volume Unit Of Measure",
            "item_display_length" => "Display Length",
            "item_display_length_unit_of_measure" => "Item Display Length Unit Of Measure",
            "bullet_point1" => "Bullet Point1",
            "bullet_point2" => "Bullet Point2",
            "bullet_point3" => "Bullet Point3",
            "bullet_point4" => "Bullet Point4",
            "bullet_point5" => "Bullet Point5",
            "recommended_browse_nodes" => "Recommended Browse Nodes",
            "generic_keywords" => "Search Terms",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords" => "Target Audience",
            "catalog_number" => "Merchant Catalog Number",
            "thesaurus_subject_keywords" => "Subject Matter",
            "main_image_url" => "Main Image URL",
            "swatch_image_url" => "Swatch Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "relationship_type" => "Relationship Type",
            "parent_sku" => "Parent SKU",
            "variation_theme" => "Variation Theme",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "prop_65" => "Consumer Notice",
            "safety_warning" => "Safety Warning",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "country_of_origin" => "Country of Origin",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "size_name" => "Size",
            "size_map" => "Size Map",
            "specific_uses_for_product" => "Specific Uses For Product",
            "mfg_minimum" => "Minimum Manufacturer Age  Recommended",
            "mfg_minimum_unit_of_measure" => "Mfg Minimum Unit Of Measure",
            "mfg_maximum" => "Maximum Manufacturer Age Recommended",
            "mfg_maximum_unit_of_measure" => "Mfg Maximum Unit Of Measure",
            "minimum_weight_recommendation" => "Minimum Weight Recommended",
            "minimum_weight_recommendation_unit_of_measure" => "Minimum Weight Recommendation Unit Of Measure",
            "maximum_weight_recommendation" => "Maximum Manufacturer Weight Recommended",
            "maximum_weight_recommendation_unit_of_measure" => "Maximum Weight Recommendation Unit Of Measure",
            "material_type" => "Material Type",
            "material_composition" => "Material Composition",
            "fabric_type" => "Fabric Type",
            "import_designation" => "Import Designation",
            "country_as_labeled" => "Country as Labeled",
            "fur_description" => "Fur Description",
            "care_instructions" => "Care Instructions",
            "assembly_instructions" => "Assembly Instructions",
            "target_gender" => "Target Gender",
            "special_features" => "Special Features",
            "lifestyle" => "Occasion Lifestyle",
            "material_type_free" => "Material Type FREE",
            "unit_count_type" => "Unit Count Unit of Measure",
            "style_name" => "Style",
            "battery_type" => "BatteryType",
            "number_of_batteries" => "Number of Batteries Required",
            "battery_average_life" => "Battery Average Life",
            "battery_average_life_unit_of_measure" => "Battery Average Life Unit Of Measure",
            "lithium_battery_weight" => "Lithium Battery Weight",
            "thesaurus_attribute_keywords" => "Other Attributes",
        );
        return $attributes;
    }
    public function amazon_healthAttributes(){
        $attributes=array(
            "item_sku" => "Seller SKU",
            "item_name" => "Product Name",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "feed_product_type" => "Product Type",
            "brand_name" => "Brand Name",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "product_description" => "Product Description",
            "item_type" => "Item Type Keyword",
            "update_delete" => "Update Delete",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "standard_price" => "Standard Price",
            "quantity" => "Quantity",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "item_package_quantity" => "Package Quantity",
            "number_of_items" => "Number of Items",
            "product_tax_code" => "Product Tax Code",
            "max_order_quantity" => "Max Order Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_height" => "Item Height",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "catalog_number" => "Catalog Number",
            "generic_keywords" => "Search Terms",
            "specific_uses_keywords" => "Intended Use",
            "thesaurus_subject_keywords" => "Subject Matter",
            "target_audience_keywords" => "Target Audience",
            "main_image_url" => "Main Image URL",
            "swatch_image_url" => "Swatch Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_length" => "Package Length",
            "package_width" => "Package Width",
            "package_height" => "Package Height",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_sku" => "Parent SKU",
            "parent_child" => "Parentage",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "safety_warning" => "Safety Warning",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "thesaurus_attribute_keywords" => "Other Attributes",
            "unit_count_type" => "Unit Count Type",
            "unit_count" => "Unit Count",
            "size_name" => "Size",
            "color_name" => "Color",
            "scent_name" => "Scent Name",
            "flavor_name" => "Flavor",
            "skin_type" => "Skin Type",
            "material_type" => "Material Type",
            "hair_type" => "Hair Type",
            "target_gender" => "Target Gender",
            "item_form" => "Item Form",
            "ingredients" => "Ingredients",
            "indications" => "Indications",
            "directions" => "Directions",
            "specialty" => "Specialty",
            "battery_type" => "Battery Type",
            "number_of_batteries" => "Number of Batteries Required",
            "lithium_battery_weight" => "Lithium Battery Weight",
            "missing_keyset_reason" => "Registered Parameter",
            "style_name" => "Style Name",
            "model_name" => "Model Name",
            "size_map" => "Size Map",
            "color_map" => "Colour Map",
            "lithium_battery_weight_unit_of_measure" => "Lithium Battery Weight Unit Of Measure",
            "maximum_weight_recommendation" => "Weight Supported",
            "weight_recommendation_unit_of_measure" => "Weight Recommendation Unit of Measure",
            "power_source_type" => "Power Source",
            "is_adult_product" => "Adult Product",
            "minimum_weight_recommendation" => "Minimum Weight Recommendation",
        );
        return $attributes;
    }
    public function amazon_foodandbeveragesAttributes(){
        $attributes=array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "brand_name" => "Brand Name",
            "manufacturer" => "Manufacturer",
            "product_description" => "Product Description",
            "feed_product_type" => "Product Type",
            "item_type" => "Item Type Keyword",
            "update_delete" => "Update Delete",
            "item_package_quantity" => "Package Quantity",
            "standard_price" => "Standard Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "quantity" => "Quantity",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "number_of_items" => "Number of Items",
            "product_tax_code" => "Product Tax Code",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "fulfillment_latency" => "Production Time",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_length" => "Item Length",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "item_width" => "Item Width",
            "item_height" => "Item Height",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "specific_uses_keywords1" => "Intended Use1",
            "specific_uses_keywords2" => "Intended Use2",
            "specific_uses_keywords3" => "Intended Use3",
            "specific_uses_keywords4" => "Intended Use4",
            "specific_uses_keywords5" => "Intended Use5",
            "generic_keywords" => "Search Terms",
            "catalog_number" => "Catalog Number",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "country_string" => "Country of declaration",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "thesaurus_attribute_keywords1" => "Other Attributes1",
            "thesaurus_attribute_keywords2" => "Other Attributes2",
            "thesaurus_attribute_keywords3" => "Other Attributes3",
            "thesaurus_attribute_keywords4" => "Other Attributes4",
            "thesaurus_attribute_keywords5" => "Other Attributes5",
            "size_name" => "Size",
            "flavor_name" => "Flavor",
            "cuisine" => "Cuisine",
            "directions" => "Directions",
            "unit_count" => "Unit Count",
            "unit_count_type" => "Unit Count Type",
            "style_name" => "Style Name",
            "each_unit_count" => "Each Unit Count",
            "product_expiration_type" => "Product Expiration Type",
            "fc_shelf_life" => "Shelf Life",
            "fc_shelf_life_pad_time" => "Shelf Life Pad Time",
            "fc_shelf_life_pad_time_2q" => "Shelf Life Pad Time 2",
            "hazmat_exception" => "Hazmat Exception",
            "hazmat_proper_shipping_name" => "Hazmat Proper Shipping Name",
            "hazmat_regulatory_packing_group" => "Hazmat Regulatory Packing Group",
            "hazmat_storage_regulatory_class" => "Hazmat Storage Regulatory Class",
            "hazmat_transportation_regulatory_class" => "Hazmat Transportation Regulatory Class",
            "hazmat_type" => "Hazmat Type",
            "hazmat_united_nations_regulatory_id" => "Hazmat United Nations Regulatory ID",
            "sales_restriction" => "Sales Restriction",
            "size_map" => "Size Map",
            "temperature_rating" => "Temperature Rating",
            "ingredients" => "Ingredients",
            "is_expiration_dated_product" => "Expiration Dated Product",
            "fc_storage_method" => "Raw Meat or Egg",
        );
        return $attributes;
    }
    public function amazon_homeAttributes(){
        $attributes=array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "product_description" => "Product Description",
            "feed_product_type" => "Product Type",
            "brand_name" => "Brand Name",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "item_type" => "Item Type Keyword",
            "update_delete" => "Update Delete",
            "model" => "model",
            "standard_price" => "Standard Price",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "quantity" => "Quantity",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "map_price" => "Minimum Advertised Price",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "fulfillment_latency" => "Fulfillment Latency",
            "product_tax_code" => "Product Tax Code",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "item_package_quantity" => "Package Quantity",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "max_order_quantity" => "Max Order Quantity",
            "number_of_items" => "Number of Items",
            "offering_start_date" => "Offering Release Date",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_display_length" => "Item Display Length",
            "item_display_width" => "Item Display Width",
            "item_display_height" => "Item Display Height",
            "display_dimensions_unit_of_measure" => "Display Dimensions Unit Of Measure",
            "item_display_weight" => "Item Display Weight",
            "item_display_weight_unit_of_measure" => "Item Display Weight Unit Of Measure",
            "volume_capacity_name" => "Volume",
            "volume_capacity_name_unit_of_measure" => "Volume Capacity Name Unit Of Measure",
            "item_height" => "Item Height",
            "item_length" => "Item Length",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_width" => "Item Width",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "target_audience_base" => "Target Audience",
            "catalog_number" => "Catalog Number",
            "specific_uses_keywords1" => "Used For1 - Used For31",
            "specific_uses_keywords2" => "Used For1 - Used For32",
            "specific_uses_keywords3" => "Used For1 - Used For33",
            "specific_uses_keywords4" => "Used For1 - Used For34",
            "specific_uses_keywords5" => "Used For1 - Used For35",
            "target_audience_keywords1" => "Target Audience1",
            "target_audience_keywords2" => "Target Audience2",
            "target_audience_keywords3" => "Target Audience3",
            "thesaurus_subject_keywords1" => "Subject Matter1",
            "thesaurus_subject_keywords2" => "Subject Matter2",
            "thesaurus_subject_keywords3" => "Subject Matter3",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "swatch_image_url" => "Swatch Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "legal_compliance_certification_metadata" => "Please provide the Executive Number (EO) required for sale into California.",
            "legal_compliance_certification_expiration_date" => "Please provide the expiration date of the EO Number.",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "country_string" => "Country of Origin",
            "country_of_origin" => "Country of Publication",
            "legal_disclaimer_description" => "Legal Disclaimer",
            "safety_warning" => "Safety Warning",
            "lighting_facts_image_url" => "Lighting Facts Label",
            "energy_efficiency_image_url" => "Energy Guide Label",
            "fabric_type" => "Fabric Type",
            "import_designation" => "Import Designation",
            "warranty_description" => "Manufacturer Warranty Description",
            "thesaurus_attribute_keywords1" => "Other Attributes1",
            "thesaurus_attribute_keywords2" => "Other Attributes2",
            "thesaurus_attribute_keywords3" => "Other Attributes3",
            "thesaurus_attribute_keywords4" => "Other Attributes4",
            "country_as_labeled" => "Country as Labeled",
            "fur_description" => "Fur Description",
            "number_of_sets" => "Number of Sets",
            "occasion" => "Occasion",
            "thread_count" => "Thread Count",
            "number_of_pieces" => "Number of Pieces",
            "item_shape" => "Shape",
            "scent_name" => "Scent Name",
            "included_components" => "Included Components",
            "light_source_type" => "Light Source Type",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "size_name" => "Size",
            "material_type" => "Material Type",
            "style_name" => "Style Name",
            "wattage" => "Wattage",
            "specific_uses_for_product" => "Specific Uses For Product",
            "special_features" => "Additional Features",
            "usda_hardiness_zone1" => "USDA Hardiness Zone1",
            "usda_hardiness_zone2" => "USDA Hardiness Zone2",
            "pattern_name" => "Pattern",
            "battery_type" => "Battery Type",
            "number_of_batteries" => "Number of Batteries Required",
            "lithium_battery_weight" => "Lithium Battery Weight",
            "specification_met" => "Specification Met",
            "mfg_minimum" => "Minimum Age Recommendation",
            "mfg_maximum" => "Maximum Age Recommendation",
            "material_composition" => "Material Composition",
            "fill_material_type" => "Fill Material Type",
            "lithium_battery_weight_unit_of_measure" => "Lithium Battery Weight Unit Of Measure",
            "wattage_unit_of_measure" => "Wattage Unit of Measure",
            "size_map" => "Size Map",
            "blade_edge_type" => "Blade Type",
            "blade_material_type" => "Blade Material Type",
            "theme" => "Theme",
            "power_source_type" => "Power Source",
            "voltage" => "Voltage",
            "engine_type" => "Engine Type",
            "hose_length" => "Hose Length",
            "hose_length_unit_of_measure" => "Hose Length Unit Of Measure",
            "paint_type" => "Paint Type",
            "ingredients" => "Ingredients",
            "age_range_description" => "Age Range Description",
            "flavor_name" => "Flavor",
            "external_testing_certification" => "External Testing Certification",
        );
        return $attributes;
    }
    public function amazon_jewelryAttributes(){
        $attributes=array(
            "item_sku" => "Seller SKU",
            "item_name" => "Title",
            "manufacturer" => "Manufacturer",
            "model" => "Model Number",
            "feed_product_type" => "Product Type",
            "item_type" => "Item Type Keyword",
            "brand_name" => "Brand Name",
            "update_delete" => "Update Delete",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "product_description" => "Product Description",
            "standard_price" => "Standard Price",
            "quantity" => "Quantity",
            "product_site_launch_date" => "Launch Date",
            "product_tax_code" => "Product Tax Code",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "merchant_release_date" => "Release Date",
            "item_package_quantity" => "Package Quantity",
            "fulfillment_latency" => "Production Time",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_display_width" => "Width",
            "item_display_length" => "Item Display Length",
            "display_dimensions_unit_of_measure" => "Display Dimensions Unit Of Measure",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_height" => "Item Height",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "target_audience_keywords1" => "Target Audience1",
            "target_audience_keywords2" => "Target Audience2",
            "target_audience_keywords3" => "Target Audience3",
            "catalog_number" => "Catalog Number",
            "specific_uses_keywords1" => "Intended Use1",
            "specific_uses_keywords2" => "Intended Use2",
            "specific_uses_keywords3" => "Intended Use3",
            "specific_uses_keywords4" => "Intended Use4",
            "specific_uses_keywords5" => "Intended Use5",
            "thesaurus_subject_keywords1" => "Subject Matter1",
            "thesaurus_subject_keywords2" => "Subject Matter2",
            "thesaurus_subject_keywords3" => "Subject Matter3",
            "thesaurus_subject_keywords4" => "Subject Matter4",
            "thesaurus_subject_keywords5" => "Subject Matter5",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "swatch_image_url" => "Swatch Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_width" => "Package Width",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_length" => "Package Length",
            "package_height" => "Package Height",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "country_of_origin" => "Country of Publication",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement1" => "Cpsia Warning1",
            "cpsia_cautionary_statement2" => "Cpsia Warning2",
            "cpsia_cautionary_statement3" => "Cpsia Warning3",
            "cpsia_cautionary_statement4" => "Cpsia Warning4",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "department_name" => "Gender",
            "thesaurus_attribute_keywords1" => "Other Attributes1",
            "thesaurus_attribute_keywords2" => "Other Attributes2",
            "thesaurus_attribute_keywords3" => "Other Attributes3",
            "thesaurus_attribute_keywords4" => "Other Attributes4",
            "thesaurus_attribute_keywords5" => "Other Attributes5",
            "total_metal_weight" => "Total Metal Weight",
            "total_metal_weight_unit_of_measure" => "Total Metal Weight Unit Of Measure",
            "total_diamond_weight" => "Total Diamond Weight",
            "total_diamond_weight_unit_of_measure" => "Total Diamond Weight Unit Of Measure",
            "total_gem_weight" => "Total Gem Weight",
            "total_gem_weight_unit_of_measure" => "Total Gem Weight Unit Of Measure",
            "material_type" => "Material Type",
            "metal_type" => "Metal Type",
            "metal_stamp" => "Metal Stamp",
            "setting_type" => "Setting Type",
            "number_of_stones" => "Number Of Stones",
            "clasp_type" => "Clasp Type",
            "chain_type" => "Chain Type",
            "ring_size" => "Ring Size",
            "ring_sizing_lower_range" => "Ring Sizing Lower Range",
            "ring_sizing_upper_range" => "Ring Sizing Upper Range",
            "back_finding" => "Back Finding",
            "gem_type1" => "Gem Type1",
            "gem_type2" => "Gem Type2",
            "gem_type3" => "Gem Type3",
            "stone_cut" => "Stone Cut",
            "stone_color1" => "Stone Color1",
            "stone_color2" => "Stone Color2",
            "stone_clarity1" => "Stone Clarity1",
            "stone_clarity2" => "Stone Clarity2",
            "stone_shape1" => "Stone Shape1",
            "stone_shape2" => "Stone Shape2",
            "stone_creation_method1" => "Stone Creation Method1",
            "stone_creation_method2" => "Stone Creation Method2",
            "stone_treatment_method1" => "Stone Treatment Method1",
            "stone_treatment_method2" => "Stone Treatment Method2",
            "stone_weight1" => "Stone Weight1",
            "stone_weight2" => "Stone Weight2",
            "certificate_type" => "Certificate Type",
            "pearl_type" => "Pearl Type",
            "pearl_minimum_color" => "Pearl Minimum Color",
            "pearl_lustre" => "Pearl Lustre",
            "pearl_shape" => "Pearl Shape",
            "pearl_uniformity" => "Pearl Uniformity",
            "pearl_surface_blemishes" => "Pearl Surface Blemishes",
            "pearl_stringing_method" => "Pearl Stringing Method",
            "size_per_pearl" => "Size Per Pearl",
            "number_of_pearls" => "Number Of Pearls",
            "style_name" => "Style",
            "color_name" => "Color",
            "color_map" => "Colour Map",
        );
        return $attributes;
    }

    public function amazon_jewelry_fr_first_row(){
        $row=array("TemplateType=jewelry","Version=2017.0302","Les 3 lignes supérieures sont réservées à Amazon.com. Ne pas modifier ou supprimer les 3 lignes supérieures.","","","","","","","","Offre-Informations sur l'offre : ces attributs sont requis pour que votre article puisse être acheté par les clients sur le site.","","","","","","","","","","","","","Dimensions-Dimensions du produit : ces attributs spécifient la taille et le poids d'un produit.","","","","","","","Découverte d'article-Informations de découverte d'article : ces attributs ont un effet sur la manière dont les clients peuvent trouver votre produit sur le site à l'aide du navigateur ou de la fonction de recherche.","","","","","","","","","","Images-Informations d'image : voir l'onglet Instructions sur l'image pour plus de détails.","","","","","","","","","","Expédition-Ces colonnes sont destinées à toute information concernant l’expédition de commandes traitées par Expédié par Amazon ou par le vendeur.","","","","","","","","","Variation-Informations de variation : diffusez ces attributs si votre produit est disponible en différents modèles (par exemple, couleur ou puissance en watts).","","","","Dégroupé - Ces attributs créer des listes de produits riches pour vos acheteurs.","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",);
        return $row;
    }
    public function amazon_jewelry_frAttributes(){
        $attributes=array(
            "item_sku"=>"SKU du vendeur [item_sku]",
            "item_name"=>"Titre [item_name]",
            "manufacturer"=>"Fabricant [manufacturer]",
            "feed_product_type"=>"Type de produit [feed_product_type]",
            "brand_name"=>"Marque [brand_name]",
            "external_product_id"=>"ID du produit [external_product_id]",
            "external_product_id_type"=>"Type d'ID du produit [external_product_id_type]",
            "product_description"=>"Description du produit [product_description]",
            "update_delete"=>"Mettre à jour Supprimer [update_delete]",
            "part_number"=>"Numéro du modèle [part_number]",
            "standard_price"=>"Prix ​​standard [standard_price]",
            "quantity"=>"quantité [quantity]",
            "currency"=>"Devise [currency]",
            "sale_price"=>"Prix réduit [sale_price]",
            "sale_from_date"=>"Date de début de la remise [sale_from_date]",
            "sale_end_date"=>"Date de fin de la remise [sale_end_date]",
            "fulfillment_latency"=>"Délai de traitement [fulfillment_latency]",
            "restock_date"=>"Date de remise en stock [restock_date]",
            "offering_can_be_gift_messaged"=>"Message cadeau disponible [offering_can_be_gift_messaged]",
            "offering_can_be_giftwrapped"=>"Emballage cadeau disponible [offering_can_be_giftwrapped]",
            "missing_keyset_reason"=>"Modification de l'identifiant produit [missing_keyset_reason]",
            "merchant_shipping_group_name"=>"Régions d’expéditions du vendeur [merchant_shipping_group_name]",
            "product_tax_code"=>"Code d'imposition du produit [product_tax_code]",
            "website_shipping_weight"=>"Poids de l'envoi [website_shipping_weight]",
            "website_shipping_weight_unit_of_measure"=>"Unité de mesure du poids de l’expédition du site internet [website_shipping_weight_unit_of_measure]",
            "item_display_diameter"=>"Diamètre du produit [item_display_diameter]",
            "item_display_length"=>"Longueur du produit [item_display_length]",
            "item_display_height"=>"Hauteur [item_display_height]",
            "item_display_width"=>"Largeur [item_display_width]",
            "display_dimensions_unit_of_measure"=>"Unité de mesure des dimensions de l’affichage [display_dimensions_unit_of_measure]",
            "target_audience_base1"=>"Cible1 [target_audience_base1]",
            "target_audience_base2"=>"Cible2 [target_audience_base2]",
            "recommended_browse_nodes"=>"Catégorie de produits (Code arborescence recommandé) [recommended_browse_nodes]",
            "bullet_point1"=>"Caractéristiques clés du produit1 [bullet_point1]",
            "bullet_point2"=>"Caractéristiques clés du produit2 [bullet_point2]",
            "bullet_point3"=>"Caractéristiques clés du produit3 [bullet_point3]",
            "generic_keywords"=>"Termes de recherche [generic_keywords]",
            "platinum_keywords1"=>"Mots-clés platinum1 [platinum_keywords1]",
            "platinum_keywords2"=>"Mots-clés platinum2 [platinum_keywords2]",
            "platinum_keywords3"=>"Mots-clés platinum3 [platinum_keywords3]",
            "main_image_url"=>"URL de l'image principale [main_image_url]",
            "swatch_image_url"=>"URL d'une image swap [swatch_image_url]",
            "other_image_url1"=>"URL d'une autre image1 [other_image_url1]",
            "other_image_url2"=>"URL d'une autre image2 [other_image_url2]",
            "other_image_url3"=>"URL d'une autre image3 [other_image_url3]",
            "other_image_url4"=>"URL d'une autre image4 [other_image_url4]",
            "other_image_url5"=>"URL d'une autre image5 [other_image_url5]",
            "other_image_url6"=>"URL d'une autre image6 [other_image_url6]",
            "other_image_url7"=>"URL d'une autre image7 [other_image_url7]",
            "other_image_url8"=>"URL d'une autre image8 [other_image_url8]",
            "fulfillment_center_id"=>"ID du centre de distribution [fulfillment_center_id]",
            "package_height"=>"Hauteur paquet [package_height]",
            "package_width_unit_of_measure"=>"Unité de mesure de la largeur du paquet [package_width_unit_of_measure]",
            "package_width"=>"largeur du colis [package_width]",
            "package_length"=>"Longueur paquet [package_length]",
            "package_length_unit_of_measure"=>"Unité de mesure longueur [package_length_unit_of_measure]",
            "package_weight"=>"Poids du Colis [package_weight]",
            "package_weight_unit_of_measure"=>"Unite de mesure Poids [package_weight_unit_of_measure]",
            "package_height_unit_of_measure"=>"Unité de mesure du poids du colis. [package_height_unit_of_measure]",
            "parent_child"=>"Parenté [parent_child]",
            "parent_sku"=>"SKU Parent [parent_sku]",
            "relationship_type"=>"Type de relation [relationship_type]",
            "variation_theme"=>"Thème de la variation [variation_theme]",
            "model"=>"Numéro de modèle [model]",
            "total_metal_weight"=>"Poids total du métal [total_metal_weight]",
            "total_metal_weight_unit_of_measure"=>"Unité de mesure du poids total du métal [total_metal_weight_unit_of_measure]",
            "total_diamond_weight"=>"Poids total du diamant [total_diamond_weight]",
            "total_gem_weight"=>"poids total de la gemme [total_gem_weight]",
            "material_type"=>"Type de matériau [material_type]",
            "metal_type"=>"Type de métal [metal_type]",
            "metal_stamp"=>"Cachet (Poinçon) métal [metal_stamp]",
            "setting_type"=>"type de sertissage [setting_type]",
            "number_of_stones"=>"Nombre de pierres [number_of_stones]",
            "clasp_type"=>"type de fermoir [clasp_type]",
            "chain_type"=>"type de chaine [chain_type]",
            "back_finding"=>"Type de fermeture de la boucle d'oreilles [back_finding]",
            "certificate_type"=>"type de certificat [certificate_type]",
            "warranty_type"=>"Type de garantie [warranty_type]",
            "warranty_description"=>"Description garantie [warranty_description]",
            "gem_type1"=>"type de gemme1 [gem_type1]",
            "gem_type2"=>"type de gemme2 [gem_type2]",
            "gem_type3"=>"type de gemme3 [gem_type3]",
            "stone_cut1"=>"Coupe (taille) de la pierre1 [stone_cut1]",
            "stone_cut2"=>"Coupe (taille) de la pierre2 [stone_cut2]",
            "stone_cut3"=>"Coupe (taille) de la pierre3 [stone_cut3]",
            "stone_color1"=>"Couleur de la pierre1 [stone_color1]",
            "stone_color2"=>"Couleur de la pierre2 [stone_color2]",
            "stone_color3"=>"Couleur de la pierre3 [stone_color3]",
            "stone_clarity1"=>"Clarté de la pierre1 [stone_clarity1]",
            "stone_clarity2"=>"Clarté de la pierre2 [stone_clarity2]",
            "stone_clarity3"=>"Clarté de la pierre3 [stone_clarity3]",
            "stone_shape1"=>"Forme de la pierre1 [stone_shape1]",
            "stone_shape2"=>"Forme de la pierre2 [stone_shape2]",
            "stone_shape3"=>"Forme de la pierre3 [stone_shape3]",
            "stone_weight1"=>"Poids de la pierre1 [stone_weight1]",
            "stone_weight2"=>"Poids de la pierre2 [stone_weight2]",
            "stone_weight3"=>"Poids de la pierre3 [stone_weight3]",
            "is_lab_created1"=>"a été créé dans un laboratoire1 [is_lab_created1]",
            "is_lab_created2"=>"a été créé dans un laboratoire2 [is_lab_created2]",
            "is_lab_created3"=>"a été créé dans un laboratoire3 [is_lab_created3]",
            "stone_symmetry1"=>"Symétrie de la pierre1 [stone_symmetry1]",
            "stone_symmetry2"=>"Symétrie de la pierre2 [stone_symmetry2]",
            "stone_symmetry3"=>"Symétrie de la pierre3 [stone_symmetry3]",
            "stone_polish1"=>"Brillance/Polissage de la pierre1 [stone_polish1]",
            "stone_polish2"=>"Brillance/Polissage de la pierre2 [stone_polish2]",
            "stone_polish3"=>"Brillance/Polissage de la pierre3 [stone_polish3]",
            "pearl_type"=>"type de perle [pearl_type]",
            "pearl_minimum_color"=>"Couleur de la perle [pearl_minimum_color]",
            "pearl_lustre"=>"Lustre de la perle [pearl_lustre]",
            "pearl_shape"=>"Forme de la perle [pearl_shape]",
            "pearl_uniformity"=>"Uniformité de la perle [pearl_uniformity]",
            "pearl_surface_blemishes"=>"Défauts superficiels de la perle [pearl_surface_blemishes]",
            "pearl_stringing_method"=>"Technique d'enfilage de perles [pearl_stringing_method]",
            "size_per_pearl"=>"taille par perle [size_per_pearl]",
            "number_of_pearls"=>"Nombre de perles [number_of_pearls]",
            "theme"=>"Thème [theme]",
            "style_name"=>"Style [style_name]",
            "model_name"=>"Model Name [model_name]",
            "item_shape"=>"Type de produit [item_shape]",
            "color_name"=>"Color [color_name]",
            "color_map"=>"couleur standardiséee [color_map]",
            "ring_size"=>"Taille de la Bague [ring_size]",
            "is_resizable"=>"est ajustable [is_resizable]",
            "ring_sizing_lower_range"=>"taille maximale en cas d'ajustement [ring_sizing_lower_range]",
            "ring_sizing_upper_range"=>"taille minimale en cas d'ajustement [ring_sizing_upper_range]",
            "occasion_type1"=>"Occasion1 [occasion_type1]",
            "occasion_type2"=>"Occasion2 [occasion_type2]",
            "occasion_type3"=>"Occasion3 [occasion_type3]",
            "occasion_type4"=>"Occasion4 [occasion_type4]",
            "occasion_type5"=>"Occasion5 [occasion_type5]",
            "occasion_type6"=>"Occasion6 [occasion_type6]",
            "occasion_type7"=>"Occasion7 [occasion_type7]",
            "occasion_type8"=>"Occasion8 [occasion_type8]",
            "occasion_type9"=>"Occasion9 [occasion_type9]",
            "occasion_type10"=>"Occasion10 [occasion_type10]",
            "occasion_type11"=>"Occasion11 [occasion_type11]",
            "occasion_type12"=>"Occasion12 [occasion_type12]",
            "occasion_type13"=>"Occasion13 [occasion_type13]",
            "occasion_type14"=>"Occasion14 [occasion_type14]",
            "occasion_type15"=>"Occasion15 [occasion_type15]",
            "occasion_type16"=>"Occasion16 [occasion_type16]",
            "occasion_type17"=>"Occasion17 [occasion_type17]",
            "occasion_type18"=>"Occasion18 [occasion_type18]",
            "occasion_type19"=>"Occasion19 [occasion_type19]",
            "occasion_type20"=>"Occasion20 [occasion_type20]",
            "occasion_type21"=>"Occasion21 [occasion_type21]",
            "occasion_type22"=>"Occasion22 [occasion_type22]",
            "occasion_type23"=>"Occasion23 [occasion_type23]",
            "occasion_type24"=>"Occasion24 [occasion_type24]",
            "occasion_type25"=>"Occasion25 [occasion_type25]",
            "occasion_type26"=>"Occasion26 [occasion_type26]",
            "occasion_type27"=>"Occasion27 [occasion_type27]",
        );
        return $attributes;
    }
    public function amazon_lightingAttributes(){
        $attributes=array(
            "item_sku" => "Seller SKU",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "item_name" => "Product Name",
            "brand_name" => "Brand Name",
            "manufacturer" => "Manufacturer",
            "part_number" => "Manufacturer Part Number",
            "product_description" => "Product Description",
            "feed_product_type" => "Product Type",
            "item_type" => "Item Type Keyword",
            "update_delete" => "Update Delete",
            "standard_price" => "Standard Price",
            "condition_type" => "Item Condition",
            "condition_note" => "Offer Condition Note",
            "quantity" => "Quantity",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "map_price" => "Minimum Advertised Price",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "fulfillment_latency" => "Production Time",
            "restock_date" => "Restock Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "product_tax_code" => "Product Tax Code",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "item_package_quantity" => "Package Quantity",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "merchant_shipping_group_name" => "Shipping-Template",
            "item_height" => "Item Height",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_dimensions_unit_of_measure" => "Item Dimensions Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_display_weight" => "Item Display Weight",
            "item_display_weight_unit_of_measure" => "Item Display Weight Unit Of Measure",
            "item_display_height" => "Item Display Height",
            "item_display_height_unit_of_measure" => "Item Display Height Unit Of Measure",
            "item_display_length" => "Item Display Length",
            "item_display_length_unit_of_measure" => "Item Display Length Unit Of Measure",
            "item_display_width" => "Item Display Width",
            "item_display_width_unit_of_measure" => "Item Display Width Unit Of Measure",
            "catalog_number" => "Catalog Number",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "specific_uses_keywords" => "Intended Use",
            "target_audience_keywords" => "Target Audience",
            "thesaurus_subject_keywords" => "Subject Matter",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "swatch_image_url" => "Swatch Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_dimensions_unit_of_measure" => "Package Dimensions Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "prop_65" => "Consumer Notice",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "country_of_origin" => "Country of Origin",
            "lighting_facts_image_url" => "Lighting Facts Label",
            "warranty_type" => "Warranty Type",
            "thesaurus_attribute_keywords" => "Other AttributesOther Attributes",
            "specification_met" => "Certification",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "specific_uses_for_product" => "Specific Uses",
            "material_type" => "Material Type",
            "style_name" => "Style Name",
            "collection_name" => "Collection",
            "included_components" => "Included Component",
            "lighting_method" => "LightingMethod",
            "shade_material_type" => "Shade Material",
            "number_of_light_sources" => "Number Of Bulb Sockets",
            "blade_color" => "Fan Blade Colour",
            "number_of_blades" => "Number Of Blades",
            "switch_type" => "Switch Style",
            "power_source_type" => "Power Source",
            "maximum_compatible_light_source_wattage" => "Maximum Supported Wattage",
            "light_source_type" => "Light Source Type",
            "item_shape" => "Item Shape",
            "wattage" => "Wattage",
            "color_temperature" => "Color Temperature",
            "special_features" => "Special Features",
            "unit_count_type" => "PPU Count Type",
            "battery_type" => "Battery Type",
            "number_of_batteries" => "Number of Batteries Required",
            "lithium_battery_weight" => "Lithium Battery Weight",
            "brightness" => "Luminous Flux",
            "voltage" => "Voltage",
            "wattage_unit_of_measure" => "Wattage Unit of Measure",
            "unit_count" => "PPU Count",
            "lithium_battery_weight_unit_of_measure" => "lithium_battery_weight_unit_of_measure",
        );
        return $attributes;
    }
    public function amazon_clothingAttributes(){
        $attributes=array(
            "item_sku" => "Seller SKU",
            "item_name" => "Product Name",
            "external_product_id" => "Product ID",
            "external_product_id_type" => "Product ID Type",
            "brand_name" => "Brand Name",
            "product_description" => "Product Description",
            "item_type" => "Item Type Keyword",
            "model" => "Style Number",
            "update_delete" => "Update Delete",
            "standard_price" => "Standard Price",
            "list_price" => "Manufacturer's Suggested Retail Price",
            "product_tax_code" => "Product Tax Code",
            "fulfillment_latency" => "Fulfillment Latency",
            "product_site_launch_date" => "Launch Date",
            "merchant_release_date" => "Release Date",
            "restock_date" => "Restock Date",
            "quantity" => "Quantity",
            "sale_price" => "Sale Price",
            "sale_from_date" => "Sale Start Date",
            "sale_end_date" => "Sale End Date",
            "max_aggregate_ship_quantity" => "Max Aggregate Ship Quantity",
            "item_package_quantity" => "Package Quantity",
            "number_of_items" => "Number of Items",
            "offering_can_be_gift_messaged" => "Offering Can Be Gift Messaged",
            "offering_can_be_giftwrapped" => "Is Gift Wrap Available",
            "is_discontinued_by_manufacturer" => "Is Discontinued by Manufacturer",
            "missing_keyset_reason" => "Registered Parameter",
            "merchant_shipping_group_name" => "Shipping-Template",
            "website_shipping_weight" => "Shipping Weight",
            "website_shipping_weight_unit_of_measure" => "Website Shipping Weight Unit Of Measure",
            "item_weight_unit_of_measure" => "Item Weight Unit Of Measure",
            "item_weight" => "Item Weight",
            "item_length_unit_of_measure" => "Item Length Unit Of Measure",
            "item_length" => "Item Length",
            "item_width" => "Item Width",
            "item_height" => "Item Height",
            "bullet_point1" => "Key Product Features1",
            "bullet_point2" => "Key Product Features2",
            "bullet_point3" => "Key Product Features3",
            "bullet_point4" => "Key Product Features4",
            "bullet_point5" => "Key Product Features5",
            "generic_keywords" => "Search Terms",
            "main_image_url" => "Main Image URL",
            "other_image_url1" => "Other Image URL1",
            "other_image_url2" => "Other Image URL2",
            "other_image_url3" => "Other Image URL3",
            "swatch_image_url" => "Swatch Image URL",
            "fulfillment_center_id" => "Fulfillment Center ID",
            "package_height" => "Package Height",
            "package_width" => "Package Width",
            "package_length" => "Package Length",
            "package_length_unit_of_measure" => "Package Length Unit Of Measure",
            "package_weight" => "Package Weight",
            "package_weight_unit_of_measure" => "Package Weight Unit Of Measure",
            "parent_child" => "Parentage",
            "parent_sku" => "Parent SKU",
            "relationship_type" => "Relationship Type",
            "variation_theme" => "Variation Theme",
            "cpsia_cautionary_statement" => "Cpsia Warning",
            "cpsia_cautionary_description" => "CPSIA Warning Description",
            "fabric_type" => "Fabric Type",
            "import_designation" => "Import Designation",
            "closure_type" => "Closure Type",
            "belt_style" => "Belt Style",
            "bottom_style" => "Bottom Style",
            "subject_character" => "character",
            "chest_size" => "Chest Size",
            "chest_size_unit_of_measure" => "Chest Size Unit Of Measure",
            "band_size_num" => "Band Size Numeric",
            "band_size_num_unit_of_measure" => "Band Size Num Unit Of Measure",
            "collar_style" => "Collar Type",
            "color_name" => "Color",
            "color_map" => "Color Map",
            "control_type" => "Control Type",
            "cup_size" => "Cup Size",
            "department_name" => "Department",
            "fabric_wash" => "Fabric Wash",
            "fit_type" => "Fit Type",
            "front_style" => "Front Pleat Type",
            "inseam_length" => "Inseam",
            "inseam_length_unit_of_measure" => "Inseam Length Unit Of Measure",
            "rise_height" => "Rise Height",
            "rise_height_unit_of_measure" => "Rise Height Unit Of Measure",
            "leg_diameter" => "Leg Diameter",
            "leg_diameter_unit_of_measure" => "Leg Diameter Unit Of Measure",
            "leg_style" => "Leg Style",
            "country_as_labeled" => "Country as Labeled",
            "fur_description" => "Fur Description",
            "opacity" => "Opacity / Transparency",
            "neck_size" => "Neck Size",
            "neck_size_unit_of_measure" => "Neck Size Unit Of Measure",
            "neck_style" => "NeckStyle",
            "pattern_type" => "Pattern Style",
            "pocket_description" => "Pocket Description",
            "rise_style" => "Rise Style",
            "shoe_width" => "Shoe Width",
            "size_name" => "Size",
            "size_map" => "Size Map",
            "special_size_type" => "Special Size Type",
            "sleeve_length" => "SleeveLength",
            "sleeve_length_unit_of_measure" => "Sleeve Length Unit Of Measure",
            "sleeve_type" => "Sleeve Type",
            "special_features" => "Additional Features",
            "strap_type" => "Strap Type",
            "style_name" => "Style",
            "theme" => "theme",
            "toe_style" => "Toe Style",
            "top_style" => "Top Style",
            "underwire_type" => "Underwire Type",
            "waist_size" => "WaistSize",
            "waist_size_unit_of_measure" => "Waist Size Unit Of Measure",
            "water_resistance_level" => "Water Resistance Level",
            "sport_type" => "Sport Type",
            "wheel_type" => "wheel-type",
        );
        return $attributes;
    }

    public function googleAttributes()
    {
        $attributes = array(
            "--1"                            => "Basic Information",
            "id"                             => "Product Id[id]",
            "title"                          => "Product Title[title]",
            "description"                    => "Product Description[description]",
            "link"                           => "Product URL[link]",
            "mobile_link"                    => "Product URL[mobile_link]",
            "product_type"                   => "Product Categories[product_type] ",
            "current_category"               => "Google Product Category[google_product_category]",
            "image"                          => "Main Image[image_link]",
            "images"                          => "Comma Separated Images [additional_image_link]",
            "images_1"                       => "Additional Image 1 [additional_image_link]",
            "images_2"                       => "Additional Image 2 [additional_image_link]",
            "images_3"                       => "Additional Image 3 [additional_image_link]",
            "images_4"                       => "Additional Image 4 [additional_image_link]",
            "images_5"                       => "Additional Image 5 [additional_image_link]",
            "images_6"                       => "Additional Image 6 [additional_image_link]",
            "images_7"                       => "Additional Image 7 [additional_image_link]",
            "images_8"                       => "Additional Image 8 [additional_image_link]",
            "images_9"                       => "Additional Image 9 [additional_image_link]",
            "images_10"                      => "Additional Image 10 [additional_image_link]",
            "condition"                      => "Condition[condition]",
            "---1"                           => "",

            "--2"                            => "Availability & Price",
            "availability"                   => "Stock Status[availability]",
            "availability_date"              => "Availability Date[availability_date]",
            "cost_of_goods_sold"             => "Cost of Goods Sold[cost_of_goods_sold]",
            "expiration_date"                => "Expiration Date[expiration_date]",
            "inventory"                      => "Facebook Inventory[inventory]",
            "price"                          => "Regular Price[price]",
            "sale_price"                     => "Sale Price[sale_price]",
            "sale_price_effective_date"      => "Sale Price Effective Date[sale_price_effective_date]",
            "---2"                           => "",

            "--3"                            => "Unique Product Identifiers",
            "brand"                          => "Manufacturer[brand]",
            "upc"                            => "GTIN[gtin]",
            "sku"                            => "MPN[mpn]",
            "identifier_exists"              => "Identifier Exist[identifier_exists]",
            "---3"                           => "",

            "--4"                            =>"Detailed Product Attributes",
            "item_group_id"                  => "Item Group Id[item_group_id]",
            "color"                          => "Color[color]",
            "gender"                         => "Gender[gender]",
            "age_group"                      => "Age Group[age_group]",
            "material"                       => "Material[material]",
            "pattern"                        => "Pattern[pattern]",
            "size"                           => "Size of the item[size]",
            "size_type"                      => "Size Type[size_type]",
            "size_system"                    => "Size System[size_system]",
            "---4"                           => "",

            "--5"                            => "Tax & Shipping",
            "tax"                            => "Tax[tax]",
            "tax_category"                   => "Tax[tax_category]",
            "shipping_country"               => "Shipping Country",
            "shipping_region"                => "Shipping Region",
            "shipping_service"               => "Shipping Service",
            "shipping_price"                 => "Shipping Price",
            "weight"                         => "Shipping Weight[shipping_weight]",
            "length"                         => "Shipping Length[shipping_length]",
            "width"                          => "Shipping Width[shipping_width]",
            "height"                         => "Shipping Height[shipping_height]",
            "shipping_label"                 => "Shipping Label[shipping_label]",
            "---5"                           => "",

            "--6"                            =>"Product Combinations",
            "multipack"                      => "Multipack[multipack]",
            "is_bundle"                      => "Is Bundle[is_bundle]",
            "---6"                           => "",

            "--7"                            => "Adult Products",
            "adult"                          => "Adult[adult]",
            "---7"                           => "",

            "--8"                            => "AdWord Attributes",
            "adwords_redirect"               => "Adwords Redirect[adwords_redirect]",
            "---8"                           => "",

            "--9"                             => "Custom Label Attributes",
            "custom_label_0"                  => "Custom label 0 [custom_label_0]",
            "custom_label_1"                  => "Custom label 1 [custom_label_1]",
            "custom_label_2"                  => "Custom label 2 [custom_label_2]",
            "custom_label_3"                  => "Custom label 3 [custom_label_3]",
            "custom_label_4"                  => "Custom label 4 [custom_label_4]",
            "---9"                            => "",

            "--10"                            => "Additional Attributes",
            "excluded_destination"            => "Excluded Destination[excluded_destination]",
            "included_destination"            => "Included Destination[included_destination]",
            "expiration_date"                 => "Expiration Date [expiration_date]",
            "---10"                           => "",

            "--11"                            => "Unit Prices (EU Countries and Switzerland Only)",
            "unit_pricing_measure"            => "Unit Pricing Measure[unit_pricing_measure]",
            "unit_pricing_base_measure"       => "Unit Pricing Base Measure[unit_pricing_base_measure]",
            "---11"                           => "",

            "--12"                            => "Energy Labels",
            "energy_efficiency_class"         => "Energy Efficiency Class[energy_efficiency_class]",
            "---12"                           => "",

            "--13"                            => "Loyalty Points (Japan Only)",
            "loyalty_points"                  => "loyalty_points[loyalty_points]",
            "---13"                           => "",

            "--14"                            => "Multiple Installments (Brazil Only)",
            "installment"                     => "Installment[installment]",
            "---14"                           => "",

            "--15"                            => "Merchant Promotions Attribute",
            "promotion_id"                    => "Promotion Id[promotion_id]",
            "---15"                           => "",
        );

        return $attributes;
    }

    public function pricegrabberAttribute(){
        $attributes = array(
            "--1"                                   =>"Required Attributes",
            "Retsku"                                =>"Retsku",
            "Product Title"                         =>"Product Title",
            "Detailed Description"                  =>"Detailed Description",
            "Categorization"                        =>"Categorization",
            "Product URL"                           =>"Product URL",
            "Primary Image URL"                     =>"Primary Image URL",
            "Selling Price"                         =>"Selling Price",
            "Regular Price"                         =>"Regular Price",
            "Condition"                             =>"Condition",
            "Availability"                          =>"Availability",
            "Manufacturer Name"                     =>"Manufacturer Name",
            "GTIN"                                  =>"GTIN (UPC / EAN / ISBN)",
            "Mature"                                =>"Mature",
            "---1"                                  =>"",
            "--2"                                   =>"Additional Attributes",
            "Parent Retsku"                         =>"Parent Retsku",
            "Merchant Categorization"               =>"Merchant Categorization",
            "Manufacturer Part Number"              =>"Manufacturer Part Number",
            "Additional Image URL 1"                =>"Additional Image URL 1",
            "Additional Image URL 2"                =>"Additional Image URL 2",
            "Additional Image URL 3"                =>"Additional Image URL 3",
            "Additional Image URL 4"                =>"Additional Image URL 4",
            "Additional Image URL 5"                =>"Additional Image URL 5",
            "Additional Image URL 6"                =>"Additional Image URL 6",
            "Additional Image URL 7"                =>"Additional Image URL 7",
            "Additional Image URL 8"                =>"Additional Image URL 8",
            "Additional Image URL 9"                =>"Additional Image URL 9",
            "Additional Image URL 10"               =>"Additional Image URL 10",
            "Video URL"                             =>"Video URL",
            "Color"                                 =>"Color",
            "Size"                                  =>"Size",
            "Material"                              =>"Material",
            "Pattern"                               =>"Pattern",
            "Gender"                                =>"Gender",
            "Age"                                   =>"Age",
            "Parent UPC"                            =>"Parent UPC",
            "Multipack"                             =>"Multipack",
            "Shipping Cost"                         =>"Shipping Cost",
            "Weight"                                =>"Weight",
            "---2"                                  =>"",
        );
        return $attributes;
    }

    public function nextagAttribute(){
        $attributes=array(
            "--1"                                   => "Required Attributes",
            "Product Name"                          =>"Product Name",
            "Product Description"                   =>"Product Description",
            "Image URL"                             =>"Image URL",
            "Click-Out URL"                         =>"Click-Out URL",
            "Price"                                 =>"Price",
            "Category"                              =>"Category: Nextag Numeric ID or Other",
            "---1"                                  => "",
            "--2"                                   => "Additional Attributes",
            "Manufacturer"                          =>"Manufacturer",
            "Condition"                             =>"Condition",
            "Stock Status"                          =>"Stock Status",
            "Cost-per-Click "                       =>"Cost-per-Click ",
            "Distributor ID "                       =>"Distributor ID ",
            "Ground Shipping"                       =>"Ground Shipping",
            "Ingram Part #"                         =>"Ingram Part #",
            "ISBN"                                  =>"ISBN",
            "Manufacturer Part #"                   =>"Manufacturer Part #",
            "Marketing Message "                    =>"Marketing Message ",
            "MUZE ID"                               =>"MUZE ID",
            "Seller Part #"                         =>"Seller Part #",
            "UPC"                                   =>"UPC",
            "Weight"                                =>"Weight",
            "ListPrice"                             =>"ListPrice",
            "---2"                                  => "",
        );
        return $attributes;
    }

    public function kelkooAttribute(){
        $attributes=array(
            "--1"                                   =>"Required Attributes",
            "title"                                 =>"title",
            "product-url"                           =>"product-url",
            "price"                                 =>"price",
            "merchant-category"                     =>"merchant-category",
            "ean"                                   =>"ean",
            "delivery-cost"                         =>"delivery-cost",
            "brand"                                 =>"brand",
            "description"                           =>"description",
            "image-url"                             =>"image-url",
            "availability"                          =>"availability",
            "mpn"                                   =>"mpn",
            "sku"                                   =>"sku",
            "---1"                                  =>"",
            "--2"                                   =>"Additional Attributes",
            "delivery-time"                         =>"delivery-time",
            "condition"                             =>"condition",
            "ecotax"                                =>"ecotax",
            "warranty"                              =>"warranty",
            "mobile-url"                            =>"mobile-url",
            "kelkoo-category-id"                    =>"kelkoo-category-id",
            "colour"                                =>"colour",
            "unit-price"                            =>"unit-price",
            "offer-type"                            =>"offer-type",
            "merchant-info"                         =>"merchant-info",
            "currency"                              =>"currency",
            "image-url-2"                           =>"image-url-2",
            "image-url-3"                           =>"image-url-3",
            "image-url-4"                           =>"image-url-4",
            "green-product"                         =>"green-product",
            "green-label"                           =>"green-label",
            "sales-rank"                            =>"sales-rank",
            "unit-quantity"                         =>"unit-quantity",
            "made-in"                               =>"made-in",
            "occasion"                              =>"occasion",
            "efficiency-class"                      =>"efficiency-class",
            "shipping-method"                       =>"shipping-method",
            "delivery-cost-2"                       =>"delivery-cost-2",
            "shipping-method-2"                     =>"shipping-method-2",
            "delivery-cost-3"                       =>"delivery-cost-3",
            "shipping-method-3"                     =>"shipping-method-3",
            "delivery-cost-4"                       =>"delivery-cost-4  ",
            "shipping-method-4"                     =>"shipping-method-4",
            "zip-code"                              =>"zip-code",
            "stock-quantity"                        =>"stock-quantity",
            "shipping-weight"                       =>"shipping-weight",
            "payment-methods"                       =>"payment-methods",
            "voucher-title"                         =>"voucher-title",
            "voucher-description"                   =>"voucher-description",
            "voucher-url"                           =>"voucher-url",
            "voucher-code"                          =>"voucher-code",
            "voucher-start-date"                    =>"voucher-start-date",
            "voucher-end-date"                      =>"voucher-end-date",
            "price-no-rebate"                       =>"price-no-rebate",
            "percentage-promo"                       =>"percentage-promo",
            "promo-start-date"                      =>"promo-start-date",
            "promo-end-dat"                         =>"promo-end-dat",
            "user-rating"                           =>"user-rating",
            "nb-reviews"                            =>"nb-reviews",
            "user-review-link"                      =>"user-review-link",
            "video-link"                            =>"video-link",
            "video-title"                           =>"video-title",
            "---2"                                  =>"",
        );
        return $attributes;
    }

    public function shopzillaAttribute(){
        $attributes=array(
            "--1"                                   =>"Required Attributes",
            "Unique ID"                             =>"Unique ID",
            "Title"                                 =>"Title",
            "Description"                           =>"Description",
            "Category"                              =>"Category",
            "Product URL"                           =>"Product URL",
            "Image URL"                             =>"Image URL",
            "Condition"                             =>"Condition",
            "Availability"                          =>"Availability",
            "Current Price"                         =>"Current Price",
            "---1"                                  =>"",
            "--2"                                   =>"Recommended Attributes",
            "Brand"                                 =>"Brand",
            "GTIN"                                  =>"GTIN",
            "MPN"                                   =>"MPN",
            "Ship Cost"                             =>"Ship Cost",
            "Ship Weight"                           =>"Ship Weight",
            "Bid"                                   =>"Bid",
            "Regular Price"                         =>"Regular Price",
            "Promo Text"                            =>"Promo Text",
            "Gender"                                =>"Gender",
            "Age Group"                             =>"Age Group",
            "Color"                                 =>"Color",
            "Size"                                  =>"Size",
            "Material"                              =>"Material",
            "Pattern"                               =>"Pattern",
            "Item Group ID"                         =>"Item Group ID",
            "---2"                                  =>"",
            "--3"                                   =>"Optional Attributes",
            "Page ID"                               =>"Page ID",
            "Page ID Variant"                       =>"Page ID Variant",
            "Generic Title"                         =>"Generic Title",
            "Unit Price"                            =>"Unit Price",
            "Currency"                              =>"Currency",
            "PZN"                                   =>"PZN",
            "Adult"                                 =>"Adult",
            "Delivery Period"                       =>"Delivery Period",
            "Energy Efficiency Class"               =>"Energy Efficiency Class",
            "---3"                                  =>"",
        );
        return $attributes;
    }

    public function shoppingAttribute(){
        $attributes=array(
            "--1"                                   =>"Required Attributes",
            "Unique Merchant SKU"                   =>"Unique Merchant SKU",
            "Product Name"                          =>"Product Name",
            "Product URL"                           =>"Product URL",
            "Image URL"                             =>"Image URL",
            "Current Price"                         =>"Current Price",
            "Stock Availability"                    =>"Stock Availability",
            "Condition"                             =>"Condition",
            "MPN"                                   =>"MPN",
            "ISBN"                                  =>"ISBN",
            "UPC"                                   =>"UPC",
            "EAN"                                   =>"EAN",
            "---1"                                  =>"",
            "--2"                                   =>"Additional Attributes",
            "Shipping Rate"                         =>"Shipping Rate",
            "Original Price"                        =>"Original Price",
            "Coupon Code"                           =>"Coupon Code",
            "Coupon Code Description"               =>"Coupon Code Description",
            "Manufacturer"                          =>"Brand / Manufacturer",
            "Product Description"                   =>"Product Description",
            "Product Type"                          =>"Product Type",
            "Category"                              =>"Category",
            "Category ID"                           =>"Category ID",
            "Parent SKU"                            =>"Parent SKU",
            "Parent Name"                           =>"Parent Name",
            "Top Seller Rank"                       =>"Top Seller Rank",
            "Estimated Ship Date"                   =>"Estimated Ship Date",
            "Gender"                                =>"Gender",
            "Color"                                 =>"Color",
            "Material"                              =>"Material",
            "Size"                                  =>"Size",
            "Size Unit of Measure"                  =>"Size Unit of Measure",
            "Age Range"                             =>"Age Range",
            "Stock Description"                     =>"Stock Description",
            "Product Launch Date"                   =>"Product Launch Date",
            "Product Bullet Point 1"                =>"Product Bullet Point 1",
            "Product Bullet Point 2"                =>"Product Bullet Point 2",
            "Product Bullet Point 3"                =>"Product Bullet Point 3",
            "Product Bullet Point 4"                =>"Product Bullet Point 4",
            "Product Bullet Point 5"                =>"Product Bullet Point 5",
            "Alternative Image URL 1"               =>"Alternative Image URL 1",
            "Alternative Image URL 2"               =>"Alternative Image URL 2",
            "Alternative Image URL 3"               =>"Alternative Image URL 3",
            "Alternative Image URL 4"               =>"Alternative Image URL 4",
            "Alternative Image URL 5"               =>"Alternative Image URL 5",
            "Mobile URL"                            =>"Mobile URL",
            "Related Products"                      =>"Related Products",
            "Merchandising Type"                    =>"Merchandising Type",
            "Zip Code"                              =>"Zip Code",
            "Shipping Weight"                       =>"Shipping Weight",
            "Format"                                =>"Format",
            "Unit Price"                            =>"Unit Price",
            "Bundle"                                =>"Bundle",
            "Software Platform"                     =>"Software Platform",
            "Watch Display Type"                    =>"Watch Display Type",
            "Custom"                                =>"Custom",
            "---2"                                  =>"",
        );
        return $attributes;
    }

    public function shopmaniaAttribute(){
        $attributes=array(
            "--1"                                   =>"Required Attributes",
            "Category"                              =>"Category",
            "Manufacturer"                          =>"Manufacturer",
            "Model"                                 =>"Model",
            "MPC"                                   =>"Merchant Code",
            "Name"                                  =>"Product name",
            "Description"                           =>"Product description",
            "URL"                                   =>"Product URL",
            "Image"                                 =>"Image URL",
            "Price"                                 =>"Product price",
            "Currency"                              =>"Currency",
            "Shipping"                              =>"Shipping cost",
            "Availability"                          =>"Availability",
            "GTIN"                                  =>"GTIN",
            "---1"                                  =>"",

        );
        return $attributes;
    }

    public function leguideAttribute(){
        $attributes=array(
            "--1"                                   =>"",
            "category" =>"category",
            "unique_id" =>"unique_id",
            "category" =>"category",
            "title"=>"title",
            "description"=>"description",
            "price"=>"price",
            "product_URL"=>"product_URL",
            "image_URL"=>"image_URL",
            "EAN"=>"EAN",
            "delivery_charge"=>"delivery_charge",
            "availability"=>"availability",
            "delivery_time"=>"delivery_time",
            "guarantee"=>"guarantee",
            "model_reference"=>"model_reference",
            "marque"=>"marque",
            "MPN"=>"MPN",
            "full_price"=>"full_price",
            "colour"=>"colour",
            "size"=>"size",
            "material"=>"material",
            "currency"=>"currency",
            "second-hand"=>"second-hand",
            "type_promotion"=>"type_promotion",
            "mobile_URL"=>"mobile_URL",
            "unit_price"=>"unit_price",
            "---1"                                  =>"",
        );
        return $attributes;
    }

    public function pricespyAttribute(){
        $attributes=array(
            "--1"                                   =>"",
            "Product-name" =>"Product-name",
            "Your-item-number" =>"Your-item-number",
            "category" =>"category",
            "price-including-gst"=>"price-including-gst",
            "Product-URL"=>"Product-URL",
            "manufacturer"=>"manufacturer",
            "manufacturer-SKU"=>"manufacturer-SKU",
            "shipping"=>"shipping",
            "image-URL"=>"image-URL",
            "stock status"=>"stock status",
            "---1"                                  =>"",
        );
        return $attributes;
    }

    public function prisjaktAttribute(){
        $attributes=array(
            "--1"                                   =>"",
            "Produktnamn" =>"Produktnamn",
            "Art.nr." =>"Art.nr.",
            "Kategori" =>"Kategori",
            "Pris inkl.moms"=>"Pris inkl.moms",
            "Produkt-URL"=>"Produkt-URL",
            "Tillverkare"=>"Tillverkare",
            "Tillverkar-SKU"=>"Tillverkar-SKU",
            "Frakt"=>"Frakt",
            "Bild-URL"=>"Bild-URL",
            "Lagerstatus"=>"Lagerstatus",
            "---1"                                  =>"",
        );
        return $attributes;
    }

    public function bingAttribute(){
        $attributes=array(
            "id"                                    =>"ID",
            "title"                                 =>"Title",
            "link"                                  =>"Product URL",
            "price"                                 =>"Price",
            "description"                           =>"Description",
            "image_link"                            =>"ImageURL",
            "shipping"                              =>"Shipping",
            "required"                              =>"",
            "brand"                                 =>"Brand",
            "mpn"                                   =>"MPN",
            "gtin"                                  =>"GTIN",
            "gender"                                =>"Gender",
            "age_group"                             =>"Age Group",
            "color"                                 =>"Color",
            "size"                                  =>"Size",
            "item_group_id"                         =>"Item Group Id",
            "material"                              =>"Material",
            "pattern"                               =>"Pattern",
            "adult"                                 =>"Adult",
            "availability"                          =>"Availability",
            "product_category"                      =>"Product Category",
            "condition"                             =>"Condition",
            "expiration_date"                       =>"Expiration Date",
            "multipack"                             =>"Multipack",
            "product_type"                          =>"Product Type",
            "mobile_link"                           =>"Mobile Link",
            "seller_name"                           =>"Seller Name",
            "bingads_grouping"                      =>"bingads_grouping",
            "bingads_label"                         =>"bingads_label",
            "bingads_redirect"                      =>"bingads_redirect",
            "custom_label_0"                        =>"custom_label_0",
            "custom_label_1"                        =>"custom_label_1",
            "custom_label_2"                        =>"custom_label_2",
            "custom_label_3"                        =>"custom_label_3",
            "custom_label_4"                        =>"custom_label_4",
            "sale_price"                            =>"Sale Price",
            "sale_price_effective_date"             =>"Sale Price Effective Date",
            "promotion_ID"                          =>"Promotion Id",
        );
        return $attributes;
    }

    public function shopbotAttribute(){
        $attributes=array(
            "--1"                                   =>"Required Attributes",
            "ID"                                    =>"ID",
            "Product Name"                          =>"Product Name",
            "URL"                                   =>"URL",
            "Category"                              =>"Category",
            "Photo URL"                             =>"Photo URL",
            "Price"                                 =>"Price",
            "Original Price"                        =>"Original Price",
            "Description"                           =>"Description",
            "MPN"                                   =>"MPN",
            "Brand"                                 =>"Brand",
            "Shipment Cost"                         =>"Shipment Cost",
            "---1"                                  =>"",
            "--2"                                   =>"Recommended Attributes",
            "Stock"                                 =>"Stock",
            "Promotional Phrase"                    =>"Promotional Phrase",
            "Model"                                 =>"Model",
            "Color"                                 =>"Color",
            "Product Type"                          =>"Product Type",
            "---2"                                  =>"",

        );
        return $attributes;
    }

    public function becomeAttribute(){
        $attributes=array(
            "--1"                                   =>"Required Attributes",
            "Unique ID"                             =>"Unique ID",
            "Title"                                 =>"Title",
            "Description"                           =>"Description",
            "Category"                              =>"Category",
            "Product URL"                           =>"Product URL",
            "Image URL"                             =>"Image URL",
            "Condition"                             =>"Condition",
            "Availability"                          =>"Availability",
            "Current Price"                         =>"Current Price",
            "---1"                                  =>"",
            "--2"                                   =>"Recommended Attributes",
            "Additional Image URL"                  =>"Additional Image URL",
            "Brand"                                 =>"Brand",
            "GTIN"                                  =>"GTIN",
            "MPN"                                   =>"MPN",
            "Ship Cost"                             =>"Ship Cost",
            "Ship Weight"                           =>"Ship Weight",
            "Bid"                                   =>"Bid",
            "Regular Price"                         =>"Regular Price",
            "Promo Text"                            =>"Promo Text",
            "Gender"                                =>"Gender",
            "Age Group"                             =>"Age Group",
            "Color"                                 =>"Color",
            "Size"                                  =>"Size",
            "Material"                              =>"Material",
            "Pattern"                               =>"Pattern",
            "Item Group ID"                         =>"Item Group ID",
            "---2"                                  =>"",
            "--3"                                   =>"Optional Attributes",
            "Page ID"                               =>"Page ID",
            "Page ID Variant"                       =>"Page ID Variant",
            "Generic Title"                         =>"Generic Title",
            "Unit Price"                            =>"Unit Price",
            "Currency"                              =>"Currency",
            "PZN"                                   =>"PZN",
            "Adult"                                 =>"Adult",
            "Delivery Period"                       =>"Delivery Period",
            "Energy Efficiency Class"               =>"Energy Efficiency Class",

            "---3"                                  =>"",
        );
        return $attributes;
    }

    public function connexityAttribute(){
        $attributes=array(
            "--1"                                   =>"Required Attributes",
            "Unique ID"                             =>"Unique ID",
            "Title"                                 =>"Title",
            "Description"                           =>"Description",
            "Category"                              =>"Category",
            "Product URL"                           =>"Product URL",
            "Image URL"                             =>"Image URL",
            "Condition"                             =>"Condition",
            "Availability"                          =>"Availability",
            "Current Price"                         =>"Current Price",
            "---1"                                  =>"",
            "--2"                                   =>"Recommended Attributes",
            "Brand"                                 =>"Brand",
            "GTIN"                                  =>"GTIN",
            "MPN"                                   =>"MPN",
            "Ship Cost"                             =>"Ship Cost",
            "Ship Weight"                           =>"Ship Weight",
            "Bid"                                   =>"Bid",
            "Regular Price"                         =>"Regular Price",
            "Promo Text"                            =>"Promo Text",
            "Gender"                                =>"Gender",
            "Age Group"                             =>"Age Group",
            "Color"                                 =>"Color",
            "Size"                                  =>"Size",
            "Material"                              =>"Material",
            "Pattern"                               =>"Pattern",
            "Item Group ID"                         =>"Item Group ID",
            "---2"                                  =>"",
            "--3"                                   =>"Optional Attributes",
            "Page ID"                               =>"Page ID",
            "Page ID Variant"                       =>"Page ID Variant",
            "Generic Title"                         =>"Generic Title",
            "Unit Price"                            =>"Unit Price",
            "Currency"                              =>"Currency",
            "PZN"                                   =>"PZN",
            "Adult"                                 =>"Adult",
            "Delivery Period"                       =>"Delivery Period",
            "Energy Efficiency Class"               =>"Energy Efficiency Class",
            "---3"                                  =>"",
        );
        return $attributes;
    }
}
